<?php
use seregazhuk\PinterestBot\Factories\PinterestBot;
use \Eventviva\ImageResize;
use DirkGroenen\Pinterest\Pinterest;
if(!function_exists('cm_get_content'))
{
    require_once("contentmaker/defines.php");
    require_once("contentmaker/server/contentmaker.functions.php");
}
function smp_get_random_user_agent() {
	$agents = array(
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36 Edge/15.15063",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36"
	);
	$rand   = rand( 0, count( $agents ) - 1 );
	return trim( $agents[ $rand ] );
}
function smp_extract_youtube_paragraphs($results, $single_post, $smp_options){
  $youtube_paragraphs = array();
  if(isset($results['items'])){
    $items = $results['items'];
  }
  else{
    $items = $results;
  }
  
  foreach($items as $item){
     $to_add = $single_post;
     $youtubeVideo = "https://www.youtube.com/embed/" . $item['youtube_id'];
     if ($smp_options['max_width'] !== '') {
        $width = $smp_options['max_width'];
     }
     else
     {
        $width = 580;
     }
     if ($smp_options['max_height'] !== '') {
        $height = $smp_options['max_height'];
     }
     else
     {
        $height = 380;
     }     
     if($smp_options['auto_play'] == 'on')
     {
        if (strpos($youtubeVideo, '?') !== false) 
        {
           $youtubeVideo .= '&autoplay=1';
        }
        else
        {
           $youtubeVideo .= '?autoplay=1';
        }
                    
     }
     if ($smp_options['closed_captions'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
              $youtubeVideo .= '&cc_load_policy=1';
         }
         else
         {
              $youtubeVideo .= '?cc_load_policy=1';
         }
     }
     if ($smp_options['white_theme'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
             $youtubeVideo .= '&color=white';
         }
         else
         {
             $youtubeVideo .= '?color=white';
         }
     }
     if ($smp_options['show_controls'] == '0') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
             $youtubeVideo .= '&controls=0';
         }
         else
         {
             $youtubeVideo .= '?controls=0';
         }
     }
     if ($smp_options['disable_key'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
             $youtubeVideo .= '&disablekb=1';
         }
         else
         {
             $youtubeVideo .= '?disablekb=1';
         }
     }
     if ($smp_options['api'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
             $youtubeVideo .= '&enablejsapi=1&origin=' . urlencode(get_site_url());
         }
         else
         {
             $youtubeVideo .= '?enablejsapi=1&origin=' . urlencode(get_site_url());
         }
     }
     if ($smp_options['stop'] != '') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
             $youtubeVideo .= '&end='.$smp_options['stop'];
         }
         else
         {
             $youtubeVideo .= '?end='.$smp_options['stop'];
         }
     }
     if ($smp_options['start'] !== '') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
             $youtubeVideo .= '&start='.$smp_options['start'];
         }
         else
         {
             $youtubeVideo .= '?start='.$smp_options['start'];
         }
     }
     if ($smp_options['fullscreen'] = 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
             $youtubeVideo .= '&fs=1';
         }
         else
         {
             $youtubeVideo .= '?fs=1';
         }
     }
     if ($smp_options['anot'] !== '1') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
              $youtubeVideo .= '&iv_load_policy='.$smp_options['anot'];
         }
         else
         {
              $youtubeVideo .= '?iv_load_policy='.$smp_options['anot'];
         }
     }
     if ($smp_options['loop'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
              $youtubeVideo .= '&loop=1';
         }
         else
         {
              $youtubeVideo .= '?loop=1';
         }
     }
     if ($smp_options['modest'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
              $youtubeVideo .= '&modestbranding=1';
         }
         else
         {
              $youtubeVideo .= '?modestbranding=1';
         }
     }
     if ($smp_options['related'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
              $youtubeVideo .= '&rel=1';
         }
         else
         {
              $youtubeVideo .= '?rel=1';
         }
     }
     if ($smp_options['info'] == 'on') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
              $youtubeVideo .= '&showinfo=1';
         }
         else
         {
              $youtubeVideo .= '?showinfo=1';
         }
     }
     if ($smp_options['lang'] !== 'default') {
         if (strpos($youtubeVideo, '?') !== false) 
         {
              $youtubeVideo .= '&hl='.$smp_options['lang'];
         }
         else
         {
              $youtubeVideo .= '?hl='.$smp_options['lang'];
         }
     }       
     $youtubeVideo = '<iframe width="'.$width.'" height="'.$height.'" src="' . esc_url_raw($youtubeVideo) . '" frameborder="0" allowfullscreen></iframe>';
     $to_add = str_replace('%%video_embed%%', $youtubeVideo, $to_add);
     $to_add = str_replace('%%video_description%%', $item['description'], $to_add);
     $to_add = str_replace('%%video_title%%', $item['title'], $to_add);
     $to_add = str_replace('%%show_image%%', '<img src="' . $item['image'] . '" alt="' . esc_html($item['title']) . '">', $to_add);
     $to_add = str_replace('%%image_url%%', $item['image'], $to_add);
     $to_add = str_replace('%%video_url%%', $item['url'], $to_add);
     $to_add = str_replace('%%video_id%%', $item['youtube_id'], $to_add);
     $to_add = str_replace('%%short_description%%', $item['preview'], $to_add);
     $youtube_paragraphs[] =  $to_add;    
  }
  return $youtube_paragraphs;
}
function smp_format_article_paragraphs($paragraphs){
  foreach($paragraphs as $i=>$paragraph){
    $paragraphs[$i] = smp_format_article_paragraph($paragraph);
  }
  return $paragraphs;
}
function smp_format_article_paragraph($paragraph){
  $paragraph = str_replace(array("<li>", "</li>"), array("",""),  $paragraph);
  return '<div class="crf_mbo"><p class="crf_full crf_center"><span>'. str_replace(array("<b>","</b>"), array("",""), $paragraph) .' </span></p></div><div class="crf_clear"></div>';
}
function smp_assemble_content($paragraphs, $youtube_paragraph, $paragraphs_2, $related_searches_paragraphs, $smp_blog_paragraphs){
  $content = "";
  if(isset($paragraphs[0])){
    $content.=$paragraphs[0];
  }
  if(isset($paragraphs[1])){
    $content.=$paragraphs[1];
  }
  if(isset($paragraphs[2])){
    $content.=$paragraphs[2];
  }
  if(isset($paragraphs[3])){
    $content.=$paragraphs[3];
  }
  if(!empty($youtube_paragraph)){
    $content.="<center>".$youtube_paragraph ."</center>";
  }
  if(isset($smp_blog_paragraphs[0])){
    $content.=$smp_blog_paragraphs[0];
  }
  if(isset($paragraphs_2[1])){
    $content.=$paragraphs_2[1];
  }
  if(isset($paragraphs_2[2])){
    $content.=$paragraphs_2[2];
  }
  if(isset($paragraphs_2[3])){
    $content.=$paragraphs_2[3];
  }
  if(isset($paragraphs_2[4])){
    $content.=$paragraphs_2[4];
  }
  if(isset($paragraphs_2[5])){
    $content.=$paragraphs_2[5];
  }
  if(isset($paragraphs_2[6])){
    $content.=$paragraphs_2[6];
  }
  if(isset($paragraphs_2[7])){
    $content.=$paragraphs_2[7];
  }
  if(isset($related_searches_paragraphs[0])){
    $content.=$related_searches_paragraphs[0];
  }
  if(isset($related_searches_paragraphs[1])){
    $content.=$related_searches_paragraphs[1];
  }
  if(isset($related_searches_paragraphs[2])){
    $content.=$related_searches_paragraphs[2];
  }
  if(isset($related_searches_paragraphs[3])){
    $content.=$related_searches_paragraphs[3];
  }
  if(isset($smp_blog_paragraphs[0])){
    $content.=$smp_blog_paragraphs[0];
  }
  if(isset($smp_blog_paragraphs[1])){
    $content.=$smp_blog_paragraphs[1];
  }
  if(isset($smp_blog_paragraphs[2])){
    $content.=$smp_blog_paragraphs[2];
  }
  if(isset($smp_blog_paragraphs[3])){
    $content.=$smp_blog_paragraphs[3];
  }
  return $content;
}
function smp_assemble_content_old($first_paragraph, $second_paragraph, $photo_paragraph, $content_paragraphs, $content_related_searches_paragraphs, $youtube_paragraph, $content_web_paragraphs, $article_paragraphs, $related_searches_paragraphs, $youtube_paragraphs, $web_paragraphs, $smp){
  if($smp){
    $content = $first_paragraph . $second_paragraph . $article_paragraphs[0] . $article_paragraphs[1] . "<center>".$youtube_paragraph ."</center>" . implode("",$content_related_searches_paragraphs). "<center>".$photo_paragraph . "</center>" .implode('', $content_web_paragraphs);
    unset($article_paragraphs[0]);
    unset($article_paragraphs[1]);
    $article_paragraphs = array_values($article_paragraphs);
  }
  else{
    $content = $first_paragraph . $second_paragraph . "<center>".$youtube_paragraph ."</center>" . implode("", $content_paragraphs).implode("",$content_related_searches_paragraphs). "<center>".$photo_paragraph . "</center>" .implode('', $content_web_paragraphs);
  }
  $text_content = strip_tags($content);
  $text_word_count = str_word_count($text_content);
  if($text_word_count < 800){
    if(count($article_paragraphs)>0){
      $i = rand(0, count($article_paragraphs)-1);
      $content_paragraphs[] = $article_paragraphs[$i];
      unset($article_paragraphs[$i]);
      $article_paragraphs = array_values($article_paragraphs);
    }
    else{
      return $content;
    }
  }
  if($content > 1200){
    if(count($content_related_searches_paragraphs)>0){
      $i = rand(0, count($content_related_searches_paragraphs)-1);
      unset($content_related_searches_paragraphs[$i]);
      $content_related_searches_paragraphs = array_values($content_related_searches_paragraphs);
      $content = smp_assemble_content($first_paragraph, $second_paragraph, $photo_paragraph, $content_paragraphs, $content_related_searches_paragraphs, $youtube_paragraph, $content_web_paragraphs, $article_paragraphs, $related_searches_paragraphs, $youtube_paragraphs, $web_paragraphs, $smp); //smp_assemble_content_old
    }
    else
    {
      return $content;
    }
  }
  return $content;  
}
function smp_get_content($settings, $single_post, $smp_options, &$image_path){
  $number_paragraphs_per_source = $settings['smp_number_rows'];
  $paragraphs = array();
  $articlesdashboard_paragraphs = array();
  $goarticles_paragraphs = array();
  $yahooanswers_paragraphs = array();
  $bigcontentsearch_paragraphs = array();
  $answerbag_paragraphs = array();
  $sources = array("youtube"=>$settings['smp_yt_api_key']);
  if(isset($smp_options['translate']) && $smp_options['translate'] != '' && $smp_options['translate'] != 'disabled')
  {
	  $translate = $smp_options['translate'];
  }
  else
  {
	  $translate = 'disabled';
  }
  if(isset($smp_options['translate_source']) && $smp_options['translate_source'] != '' && $smp_options['translate_source'] != 'disabled')
  {
	  $translate_source = $smp_options['translate_source'];
  }
  else
  {
	  $translate_source = 'disabled';
  }
  $results = cm_get_content($settings['smp_keywords'], $sources, $number_paragraphs_per_source, $translate, $translate_source);
  if(isset($results['youtube']['paragraphs'][0]['image']))
  {
      $image_path = $results['youtube']['paragraphs'][0]['image'];
  }
  else
  {
      $image_path = '';
  }
  $youtube_paragraphs = $results['youtube']['paragraphs'];
  $youtube_paragraphs = smp_format_article_paragraphs(smp_extract_youtube_paragraphs($youtube_paragraphs, $single_post, $smp_options));
  $added = 0;
  $content = '';
  while($added < $settings['smp_number_rows'] && count($youtube_paragraphs) > 0)
  {
      $i = rand(0,count($youtube_paragraphs)-1);
      if(isset($youtube_paragraphs[$i])){
          $content .= $youtube_paragraphs[$i];
          unset($youtube_paragraphs[$i]);
      }
      else
      {
          $content .= $youtube_paragraphs[0];
          unset($youtube_paragraphs[0]);
      }
      $added++;
  }
  return smpContent_filterContent($content);
}
function smpContent_filterContent($content){
  $content = str_ireplace(array('www.', '*' . '&copy;', 'http://'. '&trade;', '<ul', '<ol'), array('','','','','','<ul style=\"list-style:none;\" ', '<ol style=\"list-style:none;\" '), $content);
  return $content;
}

function smp_builtin_spin_text($content)
{
    $text = html_entity_decode($content);
    try {
        $file=file(dirname(__FILE__)  .'/synonyms.dat');
		foreach($file as $line){
			$synonyms=explode('|', $line);
			foreach($synonyms as $word){
				if(trim($word) != ''){
                    $word=str_replace('/','\/',$word);
					if(preg_match('/'. $word .'/iu', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$word.'\b/u', trim($synonyms[$rand]), $text);
					}
                    $uword=ucfirst($word);
					if(preg_match('/'. $uword .'/iu', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$uword.'\b/u', ucfirst(trim($synonyms[$rand])), $text);
					}
				}
			}
		}
    }
    catch (Exception $e) {
        return false;
    }
    return $text;
}

function smp_get_free_image($smp_options, $query_words, &$img_attr, $res_cnt = 3, $rand_page = false, $disablecache = false)
{
    $original_url = '';
    $rand_arr = array();
    if($smp_options['pixabay_api'] != '')
    {
        $rand_arr[] = 'pixabay';
    }
    if($smp_options['flickr_api'] !== '')
    {
        $rand_arr[] = 'flickr';
    }
    if($smp_options['pexels_api'] !== '')
    {
        $rand_arr[] = 'pexels';
    }
    if($smp_options['pixabay_scrape'] == 'on')
    {
        $rand_arr[] = 'pixabayscrape';
    }
    $rez = false;
    while(($rez === false || $rez === '') && count($rand_arr) > 0)
    {
        $rand = array_rand($rand_arr);
        if($rand_arr[$rand] == 'pixabay')
        {
            unset($rand_arr[$rand]);
            $rez = smp_get_pixabay_image($smp_options['pixabay_api'], $query_words, $smp_options['img_language'], $smp_options['imgtype'], $smp_options['img_orientation'], $smp_options['img_order'], $smp_options['img_cat'], $smp_options['img_mwidth'], $smp_options['img_width'], $smp_options['img_ss'], $smp_options['img_editor'], $original_url, $res_cnt, $rand_page, $disablecache);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Pixabay', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://pixabay.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'morguefile')
        {
            unset($rand_arr[$rand]);
            $rez = smp_get_morguefile_image($smp_options['morguefile_api'], $smp_options['morguefile_secret'], $query_words, $original_url, $rand_page, $disablecache);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'MorgueFile', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', 'https://morguefile.com/', $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://morguefile.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'flickr')
        {
            unset($rand_arr[$rand]);
            $rez = smp_get_flickr_image($smp_options, $query_words, $original_url, $res_cnt, $rand_page, $disablecache);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Flickr', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://www.flickr.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'pexels')
        {
            unset($rand_arr[$rand]);
            $rez = smp_get_pexels_image($smp_options, $query_words, $original_url, $res_cnt, $rand_page, $disablecache);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Pexels', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://www.pexels.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'pixabayscrape')
        {
            unset($rand_arr[$rand]);
            $rez = smp_scrape_pixabay_image($smp_options, $query_words, $original_url, $rand_page, $disablecache);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Pixabay', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://pixabay.com/', $img_attr);
            }
        }
        else
        {
            smp_log_to_file('Unrecognized free file source: ' . $rand_arr[$rand]);
            unset($rand_arr[$rand]);
        }
    }
    $img_attr = str_replace('%%image_source_name%%', '', $img_attr);
    $img_attr = str_replace('%%image_source_url%%', '', $img_attr);
    $img_attr = str_replace('%%image_source_website%%', '', $img_attr);
    return $rez;
}

function smpContent_get_pics($dir)
{
    $files = glob($dir . '/*.*');
    return $files;
}

function smp_translate($content, $from, $to)
{
	$translated = '';
    $smp_options = get_option('SMP_Options_General');
    $ch = FALSE;
    try {
        if($from == 'disabled')
        {
            $from = 'en';
        }
        if (isset($smp_options['google_trans_auth']) && trim($smp_options['google_trans_auth']) != '')
        {
            require_once(dirname(__FILE__) . "/res/translator-api.php");
            $ch = curl_init();
            if ($ch === FALSE) {
                if (isset($smp_options['enable_detailed_logging'])) {
                    smp_log_to_file('Failed to init cURL in translator!');
                }
                return false;
            }
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 10);
            $GoogleTranslatorAPI = new GoogleTranslatorAPI($ch, $smp_options['google_trans_auth']);
            $translated = '';
            $translated_title = '';
            if($content != '')
            {
                if(strlen($content) > 13000)
                {
                    while($content != '')
                    {
                        $first30k = substr($content, 0, 13000);
                        $content = substr($content, 13000);
                        $translated_temp       = $GoogleTranslatorAPI->translateText($first30k, $from, $to);
                        $translated .= ' ' . $translated_temp;
                    }
                }
                else
                {
                    $translated       = $GoogleTranslatorAPI->translateText($content, $from, $to);
                }
            }
            if($title != '')
            {
                $translated_title = $GoogleTranslatorAPI->translateText($title, $from, $to);
            }
            curl_close($ch);
        }
        else
        {
            require_once(dirname(__FILE__) . "/smp-translator.php");
            $ch = curl_init();
            if ($ch === FALSE) {
                smp_log_to_file('Failed to init cURL in translator!');
                return false;
            }
            $GoogleTranslator = new GoogleTranslator($ch);
            if($content != '')
            {
                if(strlen($content) > 13000)
                {
                    
                    while($content != '')
                    {
                        $first30k = substr($content, 0, 13000);
                        $content = substr($content, 13000);
                        $translated_temp       = $GoogleTranslator->translateText($first30k, $from, $to);
                        if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false && strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                            throw new Exception('Page content already in ' . $to);
                        }
                        if(substr_compare($translated_temp, '</pre>', -strlen('</pre>')) === 0){$translated_temp = substr_replace($translated_temp ,"", -6);}if(substr( $translated_temp, 0, 5 ) === "<pre>"){$translated_temp = substr($translated_temp, 5);}
                        $translated .= ' ' . $translated_temp;
                    }
                }
                else
                {
                    $translated       = $GoogleTranslator->translateText($content, $from, $to);
                    if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                        throw new Exception('Page content already in ' . $to);
                    }
                    if (strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                        throw new Exception('Unexpected error while translating page!');
                    }
                }
            }
            else
            {
                $translated = '';
            }
            $translated = htmlspecialchars_decode($translated);
            $translated = str_replace('. Jpg? Oh = ', '.jpg?oh=', $translated);
            $translated = str_replace(' & oe = ', '&oe=', $translated);
            curl_close($ch);
        }
    }
    catch (Exception $e) {
        curl_close($ch);
        smp_log_to_file('Exception thrown in GoogleTranslator ' . $e);
        return false;
    }
    if(substr_compare($translated, '</pre>', -strlen('</pre>')) === 0){$text = substr_replace($translated ,"", -6);}else{$text = $translated;}if(substr( $text, 0, 5 ) === "<pre>"){$text = substr($text, 5);}
    $text  = preg_replace('/' . preg_quote('html lang=') . '.*?' . preg_quote('>') . '/', '', $text);
    $text  = preg_replace('/' . preg_quote('!DOCTYPE') . '.*?' . preg_quote('<') . '/', '', $text);
    $text  = preg_replace('#https:\/\/translate\.google\.com\/translate\?hl=en&amp;prev=_t&amp;sl=en&amp;tl=pl&amp;u=([^><"\'\s\n]*)#i', urldecode('$1'), $text);
    return $text;
}

function smpContent_Populate($content){
    global $wpdb;
    $socialmp_options = get_option('SMP_Options_General');
    if (strpos($content, '[smp]') > '-1') {
        
        $smp_options = get_option('SMP_Options_General');
        $postID = get_the_ID();
        $title = get_the_title();
        $origContent = $content;
        $keywords = $title;
        $query_words = '';
        $categories = get_the_category();
        $category_id = isset($categories[0])?$categories[0]->term_id:'1';
        if(is_numeric($smp_options['count_to']) && is_numeric($smp_options['count_from']))
        {
            $results_per_post = rand($smp_options['count_from'], $smp_options['count_to']);
        }
        else
        {
            $results_per_post = 1;
        }
        if(isset($smp_options['single_video']) && $smp_options['single_video'] != '')
        {
            $single_post = stripslashes($smp_options['single_video']);
        }
        else
        {
            $single_post = '%%video_embed%%<br/>%%video_description%%';
        }
        if(isset($smp_options['attribution']) && $smp_options['attribution'] != '')
        {
            $img_attr = $smp_options['attribution'];
        }
        else
        {
            $img_attr = '';
        }
        $settings = array('smp_keywords'=>$keywords, 'smp_number_rows'=>$results_per_post, 'smp_yt_api_key'=>$smp_options['youtube_api']);
        $youtube_image = '';
        $content = smp_get_content($settings, $single_post, $smp_options, $youtube_image);
        $fimg = '';
        if(isset($smp_options['default_img']) && $smp_options['default_img'] != '')
        {
            $default_img_list = preg_split("/\\r\\n|\\r|\\n/", $smp_options['default_img']);
            $randIndex = array_rand($default_img_list);
            $def_img = trim($default_img_list[$randIndex]);
            if (!filter_var($def_img, FILTER_VALIDATE_URL)) {
                $randIndex = array_rand($default_img_list);
                $def_img = trim($default_img_list[$randIndex]);
                if (!filter_var($def_img, FILTER_VALIDATE_URL)) {
                    $def_img = '';
                }
            }
        }
        else
        {
            $def_img = '';
        }
        if($smp_options['image'] == 'youtube')
        {
            $img_attr = '';
            if($youtube_image != '')
            {
                if (!$fimg = smp_generate_featured_image($youtube_image, $postID)) {
                    smp_log_to_file('smp_generate_featured_image (yt) failed for ' . $youtube_image . '!');
                }
            }
            else
            {
                if($def_img != '')
                {
                    if (!$fimg = smp_generate_featured_image($def_img, $postID)) {
                        smp_log_to_file('smp_generate_featured_image (yt default) failed for ' . $def_img . '!');
                    }
                }
            }
        }
        elseif($smp_options['image'] == 'static')
        {
            $img_attr = '';
            if($def_img != '')
            {
                if (!$fimg = smp_generate_featured_image($def_img, $postID)) {
                    smp_log_to_file('smp_generate_featured_image (yt default) failed for ' . $def_img . '!');
                }
            }
        }
        elseif($smp_options['image'] == 'random')
        {
            $img_attr = '';
            $ifile = '';
            $upload_dir = wp_upload_dir();
            global $wp_filesystem;
            if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                wp_filesystem($creds);
            }
            if(isset($smp_options['subdir']) && $smp_options['subdir'] != '')
            {
                if(!$wp_filesystem->exists($smp_options['subdir']))
                {
                    if(stristr($upload_dir['basedir'], $smp_options['subdir']) !== false)
                    {
                        $smp_options['subdir'] = str_replace($upload_dir['basedir'], '', $smp_options['subdir']);
                    }
                    if(stristr($upload_dir['baseurl'], $smp_options['subdir']) !== false)
                    {
                        $smp_options['subdir'] = str_replace($upload_dir['baseurl'], '', $smp_options['subdir']);
                    }
                    $smp_options['subdir'] = trim($smp_options['subdir'], '\\');
                    $smp_options['subdir'] = trim($smp_options['subdir'], '/');
                    $smp_options['subdir'] = trim($smp_options['subdir']);
                    if($smp_options['subdir'] != '')
                    {
                        $ifile = $upload_dir['basedir'] . '/' . $smp_options['subdir'];
                    }
                }
                else
                {
                    $ifile = $smp_options['subdir'];
                }
            }
            else
            {
                $ifile = $upload_dir['basedir'];
            }
            if ($ifile == '' || !$wp_filesystem->exists($ifile)) {
                smp_log_to_file('Folder does not exists: '. $ifile);
            }
            else
            {
                $rand_posted = false;
                $pic_arr = smpContent_get_pics($ifile);
                if(count($pic_arr) == 0)
                {
                    smp_log_to_file('Folder does not contain any usable image files: '. $ifile);
                }
                else
                {
                    $posted_arr = get_option('smp_already_posted', array());
                    $pic_arr_tmp = array_diff ($pic_arr, $posted_arr);
                    if(count($pic_arr_tmp) == 0)
                    {
                        smp_log_to_file('All images are already posted from: '. $ifile);
                        update_option('smp_already_posted', array());
                        $pic_arr_tmp = $pic_arr;
                    }
                    {
                        $randz = array_rand($pic_arr_tmp);
                        $post_img_me = $pic_arr_tmp[$randz];
                        $post_img_me = str_replace($upload_dir['basedir'], $upload_dir['baseurl'], $post_img_me);
                        if (!$fimg = smp_generate_featured_image($post_img_me, $postID)) {
                            smp_log_to_file('smp_generate_featured_image (random) failed for ' . $post_img_me . '!');
                        }
                        else
                        {
                            $posted_arr[] = $pic_arr_tmp[$randz];
                            update_option('smp_already_posted', $posted_arr);
                            $rand_posted = true;
                        }
                    }
                }
                if($rand_posted === false)
                {
                    if($def_img != '')
                    {
                        if (!$fimg = smp_generate_featured_image($def_img, $postID)) {
                            smp_log_to_file('smp_generate_featured_image (yt default) failed for ' . $def_img . '!');
                        }
                    }
                }
            }
        }
        elseif($smp_options['image'] == 'free')
        {
            if($smp_options['pixabay_api'] != '' || ($smp_options['morguefile_api'] !== '' && $smp_options['morguefile_secret'] !== '') || $smp_options['flickr_api'] !== '' || $smp_options['pexels_api'] !== '' || $smp_options['pixabay_scrape'] == 'on')
            {
                $img_free = '';
                if($smp_options['rimage'] == 'on')
                {
                    $rand_page = true;
                }
                else
                {
                    $rand_page = false;
                }
                if($smp_options['disablecache'] == 'on')
                {
                    $disablecache = true;
                }
                else
                {
                    $disablecache = false;
                }
                if(str_word_count($title) <= 3)
                {
                    $query_words = $title;
                    if($smp_options['bimage'] == 'on')
                    {
                        $randn = rand(1,10);
                        if($randn <= 8)
                        {
                            $query_words_tmp = smp_builtin_spin_text($query_words);
                            if($query_words_tmp !== false)
                            {
                                $query_words = $query_words_tmp;
                            }
                        }
                    }
                    $img_free = smp_get_free_image($smp_options, $query_words, $img_attr, 3, $rand_page, $disablecache);
                }
                if($img_free === false || $img_free === '')
                {
                    $keyword_class = new Smp_keywords();
                    $query_words = $keyword_class->keywords($title, 2);
                    if($smp_options['bimage'] == 'on')
                    {
                        $randn = rand(1,10);
                        if($randn <= 8)
                        {
                            $query_words_tmp = smp_builtin_spin_text($query_words);
                            if($query_words_tmp !== false)
                            {
                                $query_words = $query_words_tmp;
                            }
                        }
                    }
                    $img_free = smp_get_free_image($smp_options, $query_words, $img_attr, 50, $rand_page, $disablecache);
                    if($img_free === false || $img_free === '')
                    {
                        $query_words = $keyword_class->keywords($title, 1);
                        if($smp_options['bimage'] == 'on')
                        {
                            $randn = rand(1,10);
                            if($randn <= 8)
                            {
                                $query_words_tmp = smp_builtin_spin_text($query_words);
                                if($query_words_tmp !== false)
                                {
                                    $query_words = $query_words_tmp;
                                }
                            }
                        }
                        $img_free = smp_get_free_image($smp_options, $query_words, $img_attr, 100, $rand_page, $disablecache);
                        if($img_free === false || $img_free === '')
                        {
                            $query_words = $keyword_class->keywords($title, 1, true);
                            if($smp_options['bimage'] == 'on')
                            {
                                $randn = rand(1,10);
                                if($randn <= 8)
                                {
                                    $query_words_tmp = smp_builtin_spin_text($query_words);
                                    if($query_words_tmp !== false)
                                    {
                                        $query_words = $query_words_tmp;
                                    }
                                }
                            }
                            $img_free = smp_get_free_image($smp_options, $query_words, $img_attr, 200, $rand_page, $disablecache);
                            if($img_free === false || $img_free === '')
                            {
                                $img_attr = '';
                                if($def_img != '')
                                {
                                    if (!$fimg = smp_generate_featured_image($def_img, $postID)) {
                                        smp_log_to_file('smp_generate_featured_image (free default) failed for ' . $def_img . '!');
                                    }
                                }
                            }
                            else
                            {
                                if (!$fimg = smp_generate_featured_image($img_free, $postID)) {
                                    smp_log_to_file('smp_generate_featured_image (free) failed for ' . $youtube_image . '!');
                                }
                            }
                        }
                        else
                        {
                            if (!$fimg = smp_generate_featured_image($img_free, $postID)) {
                                smp_log_to_file('smp_generate_featured_image (free) failed for ' . $youtube_image . '!');
                            }
                        }
                    }
                    else
                    {
                        if (!$fimg = smp_generate_featured_image($img_free, $postID)) {
                            smp_log_to_file('smp_generate_featured_image (free) failed for ' . $youtube_image . '!');
                        }
                    }
                }
                else
                {
                    if (!$fimg = smp_generate_featured_image($img_free, $postID)) {
                        smp_log_to_file('smp_generate_featured_image (free) failed for ' . $youtube_image . '!');
                    }
                }
            }
            else
            {
                $img_attr = '';
                if($def_img != '')
                {
                    if (!$fimg = smp_generate_featured_image($def_img, $postID)) {
                        smp_log_to_file('smp_generate_featured_image (free default) failed for ' . $def_img . '!');
                    }
                }
            }
        }
        else
        {
            $img_attr = '';
        }
        $query_hashtags2 = '';
        if(isset($socialmp_options['tags']) && $socialmp_options['tags'] != '')
        {
            $ws = explode(',', $socialmp_options['tags']);
            $ws = array_slice($ws, 0, 2);
            $ws = implode(' ', $ws);
            $query_hashtags2 = smp_autotag($ws);
        }
        
        $query_hashtags = smp_autotag($query_words);
        $prepend = stripslashes(isset($smp_options['prepend'])?$smp_options['prepend']:"");
        $prepend = str_replace('%%post_featured_image_url%%', $fimg, $prepend);
        $prepend = str_replace('%%image_attribution%%', $img_attr, $prepend);
        $prepend = str_replace('%%post_title%%', $title, $prepend);
        $prepend = str_replace('%%image_search_hashtags%%', $query_hashtags, $prepend);
        $prepend = str_replace('%%image_tag_hashtags%%', $query_hashtags2, $prepend);
        $prepend = str_replace('%%image_search_terms%%', $query_words, $prepend);
        if($fimg != '')
        {
            $prepend = str_replace('%%post_show_image%%', '<img src="' . esc_url_raw($fimg) . '" alt="' . esc_html($title) . '"/>', $prepend);
        }
        else
        {
            $prepend = str_replace('%%post_show_image%%', '', $prepend);
        }
        if ($prepend != '') {
            $prepend = str_replace('\"', '"', $prepend);
            $spintax = new Smp_Spintax();
            $prepend = $spintax->Parse($prepend);
        }
        $append = stripslashes(isset($smp_options['append'])?$smp_options['append']:"");
        $append = str_replace('%%post_featured_image_url%%', $fimg, $append);
        $append = str_replace('%%image_attribution%%', $img_attr, $append);
        $append = str_replace('%%post_title%%', $title, $append);
        $append = str_replace('%%image_search_terms%%', $query_words, $append);
        $append = str_replace('%%image_search_hashtags%%', $query_hashtags, $append);
        $append = str_replace('%%image_tag_hashtags%%', $query_hashtags2, $append);
        if($fimg != '')
        {
            $append = str_replace('%%post_show_image%%', '<img src="' . esc_url_raw($fimg) . '" alt="' . esc_html($title) . '"/>', $append);
        }
        else
        {
            $append = str_replace('%%post_show_image%%', '', $append);
        }
        if ($append != '') {
            $append = str_replace('\"', '"', $append);
            $spintax = new Smp_Spintax();
            $append = $spintax->Parse($append);
        }
        if ($content != '') {
            $content = str_replace('[smp]', $prepend . $content . $append, $origContent);
        }
        else 
        {
            $content = str_replace('[smp]', $prepend . $append, $origContent);
        }
        $wpdb->update(
            $wpdb->posts, array(
               'post_content' => $content
            ), array('ID' => $postID), array('%s'), array('%d')
        );
        $smp_Pinterest_Settings = get_option('smp_Pinterest_Settings', false);
        if (isset($smp_Pinterest_Settings['smp_posting']) && $smp_Pinterest_Settings['smp_posting'] == 'on') {
            $post = get_post($postID);
            if($post === null)
            {
                smp_log_to_file('Failed to get post by id: ' . $postID);
                return $content;
            }
            if (isset($smp_Pinterest_Settings['delay_post']) && $smp_Pinterest_Settings['delay_post'] != '' && is_numeric($smp_Pinterest_Settings['delay_post'])) {
                if(wp_next_scheduled('smp_new_post_cron', array($post, $content, $fimg, $query_hashtags)) === false)
                {
                    wp_schedule_single_event( time() + intval($smp_Pinterest_Settings['delay_post']), 'smp_new_post_cron', array($post, $content, $fimg, $query_hashtags) );
                }
            }
            else
            {
                smp_do_post($post, $content, $fimg, $query_hashtags);
            }
        }
    }
    return $content;
}

function smp_autotag($input) {
   $terms = explode(' ', $input);
   $tmp = array();   
   foreach($terms as $term){
      $tmp[] = "/(\b$term\b)/i";
   }
   $out = preg_replace($tmp, '#$0', $input);
   return $out;
}

function smp_generate_thumbmail( $post_id )
    {
        $post = get_post($post_id);
        $post_parent_id = $post->post_parent === 0 ? $post->ID : $post->post_parent;
        
        if ( has_post_thumbnail($post_parent_id) )
        {
            if ($id_attachment = get_post_thumbnail_id($post_parent_id)) {
                $the_image  = wp_get_attachment_url($id_attachment, false);
                return $the_image;
            }
        }
        $attachments = array_values(get_children(array(
            'post_parent' => $post_parent_id, 
            'post_status' => 'inherit', 
            'post_type' => 'attachment', 
            'post_mime_type' => 'image', 
            'order' => 'ASC', 
            'orderby' => 'menu_order ID') 
        ));
        if( sizeof($attachments) > 0 ) {
            $the_image  = wp_get_attachment_url($attachments[0]->ID, false);
            return $the_image;
        }
        $media = get_attached_media('image', $post_id);
        if( sizeof($media) > 0 ) {
            $the_image  = wp_get_attachment_url($media[0]->ID, false);
            return $the_image;
        }
        $image_url = smp_extractThumbnail($post->post_content);
        return $image_url;
    }
    
function smp_get_mime ($filename) {
    $mime_types = array(
        'txt' => 'text/plain',
        'htm' => 'text/html',
        'html' => 'text/html',
        'php' => 'text/html',
        'css' => 'text/css',
        'js' => 'application/javascript',
        'json' => 'application/json',
        'xml' => 'application/xml',
        'swf' => 'application/x-shockwave-flash',
        'flv' => 'video/x-flv',
        'png' => 'image/png',
        'jpe' => 'image/jpeg',
        'jpeg' => 'image/jpeg',
        'jpg' => 'image/jpeg',
        'gif' => 'image/gif',
        'bmp' => 'image/bmp',
        'ico' => 'image/vnd.microsoft.icon',
        'tiff' => 'image/tiff',
        'mts' => 'video/mp2t',
        'tif' => 'image/tiff',
        'svg' => 'image/svg+xml',
        'svgz' => 'image/svg+xml',
        'zip' => 'application/zip',
        'rar' => 'application/x-rar-compressed',
        'exe' => 'application/x-msdownload',
        'msi' => 'application/x-msdownload',
        'cab' => 'application/vnd.ms-cab-compressed',
        'mp3' => 'audio/mpeg',
        'qt' => 'video/quicktime',
        'mov' => 'video/quicktime',
        'wmv' => 'video/x-ms-wmv',
        'mp4' => 'video/mp4',
        'm4p' => 'video/m4p',
        'm4v' => 'video/m4v',
        'mpg' => 'video/mpg',
        'mp2' => 'video/mp2',
        'mpe' => 'video/mpe',
        'mpv' => 'video/mpv',
        'm2v' => 'video/m2v',
        'm4v' => 'video/m4v',
        '3g2' => 'video/3g2',
        '3gpp' => 'video/3gpp',
        'f4v' => 'video/f4v',
        'f4p' => 'video/f4p',
        'f4a' => 'video/f4a',
        'f4b' => 'video/f4b',
        '3gp' => 'video/3gp',
        'avi' => 'video/x-msvideo',
        'mpeg' => 'video/mpeg',
        'mpegps' => 'video/mpeg',
        'webm' => 'video/webm',
        'mpeg4' => 'video/mp4',
        'mkv' => 'video/mkv',
        'pdf' => 'application/pdf',
        'psd' => 'image/vnd.adobe.photoshop',
        'ai' => 'application/postscript',
        'eps' => 'application/postscript',
        'ps' => 'application/postscript',
        'doc' => 'application/msword',
        'rtf' => 'application/rtf',
        'xls' => 'application/vnd.ms-excel',
        'ppt' => 'application/vnd.ms-powerpoint',
        'docx' => 'application/msword',
        'xlsx' => 'application/vnd.ms-excel',
        'pptx' => 'application/vnd.ms-powerpoint',
        'odt' => 'application/vnd.oasis.opendocument.text',
        'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
    );
    $ext = array_values(array_slice(explode('.', $filename), -1));$ext = $ext[0];

    if(stristr($filename, 'dailymotion.com'))
    {
        return 'application/octet-stream';
    }
    if (function_exists('mime_content_type')) {
        error_reporting(0);
        $mimetype = mime_content_type($filename);
        error_reporting(E_ALL);
        if($mimetype == '')
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;
    }
    elseif (function_exists('finfo_open')) {
        $finfo = finfo_open(FILEINFO_MIME);
        $mimetype = finfo_file($finfo, $filename);
        finfo_close($finfo);
        if($mimetype === false)
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;

    } elseif (array_key_exists($ext, $mime_types)) {
        return $mime_types[$ext];
    } else {
        return 'application/octet-stream';
    }
}
function smp_extractThumbnail($content) {
    $smp_Pinterest_Settings = get_option('smp_Pinterest_Settings', false);
    $att = smp_getUrls($content);
    if(count($att) > 0)
    {
        foreach($att as $link)
        {
            if(!(isset($smp_Pinterest_Settings['only_local']) && $smp_Pinterest_Settings['only_local'] == 'on') || smp_IsResourceLocal($link))
            {
                $mime = smp_get_mime($link);
                if(stristr($mime, "image/") !== FALSE){
                    return $link;
                }
            }
        }
    }
    else
    {
        return '';
    }
    return '';
}
function smp_require_all($dir) {
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $scan = glob("$dir/*");
    foreach ($scan as $path) {
        if ($wp_filesystem->is_dir($path)) {
            smp_require_all($path);
        }
        elseif (preg_match('/\.php$/', $path)) {
            
            include_once $path;
        }
    }
}
add_action('smp_new_post_cron', 'smp_do_post', 10, 4);
function smp_do_post($post, $content, $featured_image, $query_hashtags)
{
    $smp_options = get_option('SMP_Options_General');
    $smp_Pinterest_Settings = get_option('smp_Pinterest_Settings', false);
    if (isset($smp_options['rule_timeout']) && $smp_options['rule_timeout'] != '') {
        $timeout = intval($smp_options['rule_timeout']);
    } else {
        $timeout = 3600;
    }
    ini_set('safe_mode', 'Off');
    ini_set('max_execution_time', $timeout);
    ini_set('ignore_user_abort', 1);
    ini_set('user_agent', smp_get_random_user_agent());
    if(function_exists('ignore_user_abort'))
{
    ignore_user_abort(true);
}
    if(function_exists('set_time_limit'))
{
    set_time_limit($timeout);
}
    if (isset($smp_Pinterest_Settings['smp_posting']) && $smp_Pinterest_Settings['smp_posting'] == 'on') 
    {
        if (isset($smp_options['posting_method']) && $smp_options['posting_method'] == 'cred') {
            if (!isset($smp_options['user_name']) || $smp_options['user_name'] == '') {
                smp_log_to_file('Please insert your user name in plugin settings before we can automatically publish on Pinterest.');
                return;
            }
            if (!isset($smp_options['user_pass']) || $smp_options['user_pass'] == '') {
                smp_log_to_file('Please insert your user password in plugin settings before we can automatically publish on Pinterest.');
                return;
            }
        }
        else
        {
            if (!isset($smp_options['app_id']) || $smp_options['app_id'] == '') {
                smp_log_to_file('Please insert your ID in plugin settings before we can automatically publish on Pinterest.');
                return;
            }
            if (!isset($smp_options['app_secret']) || $smp_options['app_secret'] == '') {
                smp_log_to_file('Please insert your app secret in plugin settings before we can automatically publish on Pinterest.');
                return;
            }
            $logged_user = get_option('smp_auth_id', false);
            $logged_pass = get_option('smp_auth_secret', false);
            $access_token = get_option('smp_access_token', false);
            if($logged_user == '' || $logged_user != $smp_options['app_id'] || $logged_pass != $smp_options['app_secret'])
            {
                smp_log_to_file('Please approve your App in plugin settings before you can use this feature!');
                return;
            }
        }
        
        if (isset($smp_Pinterest_Settings['post_posts'])) {
            if ($smp_Pinterest_Settings['post_posts'] == 'on' && 'post' === $post->post_type) {
                return;
            }
        }
        if (isset($smp_options['posting_method']) && $smp_options['posting_method'] == 'cred') {
        }
        else
        {
            if (!isset($smp_Pinterest_Settings['board_select']) || $smp_Pinterest_Settings['board_select'] == '' || !is_array($smp_Pinterest_Settings['board_select'])  || count($smp_Pinterest_Settings['board_select']) == 0) {
                return;
            }
        }
        if (isset($smp_Pinterest_Settings['post_pages'])) {
            if ($smp_Pinterest_Settings['post_pages'] == 'on' && 'page' === $post->post_type) {
                return;
            }
        }
        if (isset($smp_Pinterest_Settings['post_custom'])) {
            if ($smp_Pinterest_Settings['post_custom'] == 'on' && 'page' != $post->post_type && 'post' != $post->post_type) {
                if (isset($smp_Pinterest_Settings['except_type']) && $smp_Pinterest_Settings['except_type'] != '') 
                {
                    $excepted_types = explode(',', $smp_Pinterest_Settings['except_type']);
                    $excepted_types = array_map('trim', $excepted_types);
                    if(!in_array($post->post_type, $excepted_types))
                    {
                        return;
                    }
                }
                else
                {
                    return;
                }
            }
        }
        $meta = get_post_meta($post->ID, "smp_published", true);
        if ($meta == 'pub') {
            return;
        }
        
            $post_link = get_permalink($post->ID);
            $post_title       = html_entity_decode($post->post_title);
            $blog_title       = html_entity_decode(get_bloginfo('title'));
            $post_excerpt     = html_entity_decode($post->post_excerpt);
            $post_content     = do_shortcode(html_entity_decode($post->post_content));
            if(function_exists('do_blocks'))
            {
                $post_content     = do_blocks($post_content);
            }
            $post_content = apply_filters( 'the_content', $post_content);
            $post_description = $post_excerpt;
            $author_obj       = get_user_by('id', $post->post_author);
            if(isset($author_obj->user_nicename))
            {
                $user_name        = $author_obj->user_nicename;
            }
            else
            {
                $user_name        = 'Administrator';
            }
            if($featured_image == '')
            {
                wp_suspend_cache_addition(true);
                $metas = get_post_custom($post->ID);
                wp_suspend_cache_addition(false);
                $rez_meta = smp_preg_grep_keys('#.+?_featured_ima?ge?#i', $metas);
                if(count($rez_meta) > 0)
                {
                    foreach($rez_meta as $rm)
                    {
                        if(isset($rm[0]) && filter_var($rm[0], FILTER_VALIDATE_URL))
                        {
                            $featured_image = $rm[0];
                            break;
                        }
                    }
                }
                if($featured_image == '')
                {
                    $featured_image = smp_generate_thumbmail($post->ID);;
                }
                if($featured_image == '' && $content != '')
                {
                    $dom     = new DOMDocument();
                    $internalErrors = libxml_use_internal_errors(true);
                    $dom->loadHTML(do_shortcode($content));
                    libxml_use_internal_errors($internalErrors);
                    $tags      = $dom->getElementsByTagName('img');
                    foreach ($tags as $tag) {
                        $temp_get_img = $tag->getAttribute('src');
                        if ($temp_get_img != '') {
                            $temp_get_img = strtok($temp_get_img, '?');
                            $featured_image = rtrim($temp_get_img, '/');
                        }
                    }
                }
                if($featured_image == '')
                {
                    return;
                }
            }
            $post_cats = get_post_meta($post->ID, 'smp_post_cats', true);
            if($post_cats == '')
            {
                $post_categories = wp_get_post_categories( $post->ID );
                foreach($post_categories as $c){
                    $cat = get_category( $c );
                    $post_cats .= $cat->name . ',';
                }
                $post_cats = trim($post_cats, ',');
            }
            
            if($post_cats != '')
            {
                $post_categories = explode(',', $post_cats);
            }
            else
            {
                $post_categories = array();
            }
            if(count($post_categories) == 0)
            {
                $terms = get_the_terms( $post->ID, 'product_cat' );
                if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
                    foreach ( $terms as $term ) {
                        $post_categories[] = $term->slug;
                    }
                    $post_cats = implode(',', $post_categories);
                }
                
            }
            
            foreach($post_categories as $pc)
            {
                if (isset($smp_Pinterest_Settings['disabled_categories']) && !empty($smp_Pinterest_Settings['disabled_categories'])) {
                    foreach($smp_Pinterest_Settings['disabled_categories'] as $disabled_cat)
                    {
                        if(trim($pc) == get_cat_name($disabled_cat))
                        {
                            return;
                        }
                    }
                }
            }
            $post_tagz = get_post_meta($post->ID, 'smp_post_tags', true);
            if($post_tagz == '')
            {
                $post_tags = wp_get_post_tags( $post->ID );
                foreach($post_tags as $t){
                    $post_tagz .= $t->name . ',';
                }
                $post_tagz = trim($post_tagz, ',');
            }
            
            if($post_tagz != '')
            {
                $post_tags = explode(',', $post_tagz);
            }
            else
            {
                $post_tags = array();
            }
            if(count($post_tags) == 0)
            {
                $terms = get_the_terms( $post->ID, 'product_tag' );
                if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
                    foreach ( $terms as $term ) {
                        $post_tags[] = $term->slug;
                    }
                    $post_tagz = implode(',', $post_tags);
                }
                
            }
            
            $post_template    = $smp_Pinterest_Settings['pinterest_format'];
            $post_template    = smp_replacePinterestPostShortcodes($post_template, $post_link, $post_title, $blog_title, $post_excerpt, $post_content, $user_name, $featured_image, $post_cats, $post_tagz, $query_hashtags);
            foreach($post_tags as $pt)
            {
                if (isset($smp_Pinterest_Settings['disable_tags']) && $smp_Pinterest_Settings['disable_tags'] != '') {
                    
                    $disable_tags = explode(",", $smp_Pinterest_Settings['disable_tags']);
                    foreach($disable_tags as $disabled_tag)
                    {
                        if(trim($pt) == trim($disabled_tag))
                        {
                            return;
                        }
                    }
                }
            }
            
            $post_added = false;
            if(isset($smp_Pinterest_Settings['pin_urls']) && $smp_Pinterest_Settings['pin_urls'] != '')
            {
                $pin_list = explode(',', $smp_Pinterest_Settings['pin_urls']);
                $blogUrl = trim($pin_list[array_rand($pin_list)]);  
            }
            else
            {
                $blogUrl = get_permalink($post);
            }
            $pin_me_arr = array();
            if(isset($smp_Pinterest_Settings['pin_each']) && $smp_Pinterest_Settings['pin_each'] == 'on')
            {
                $pin_me_arr_t = smp_get_images(do_shortcode($content), true);
                if(count($pin_me_arr_t) > 0)
                {
                    foreach($pin_me_arr_t as $patx)
                    {
                        if(isset($patx->attr->src))
                        {
                            $pin_me_arr[] = $patx->attr->src;
                        }
                    }
                    if(count($pin_me_arr) == 0)
                    {
                        $pin_me_arr = array($featured_image);
                    }
                }
                else
                {
                    $pin_me_arr = array($featured_image);
                }
            }
            else
            {
                $pin_me_arr = array($featured_image);
            }
            if (isset($smp_options['posting_method']) && $smp_options['posting_method'] == 'cred')
            {
                try {
                    require 'autoload.php';
                }
                catch(Exception $e)
                {
                    smp_log_to_file('Exception thrown in autoload.php: ' . $e->getMessage());
                    return;
                }
            }
            else
            {
                    $instFile = dirname(__FILE__) . "/Pinterest/autoload.php";
                    global $wp_filesystem;
                    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                        wp_filesystem($creds);
                    }
                    if ($wp_filesystem->exists($instFile) && $wp_filesystem->is_readable($instFile)) {
                        try
                        {
                            if(!class_exists('\DirkGroenen\Pinterest\Pinterest'))
                            {
                                require_once($instFile);
                            }
                        }
                        catch (Exception $e) {
                            smp_log_to_file('Exception thrown in Pinterest/autoload.php: ' . $e->getMessage());
                            return;
                        }
                    }
                    else
                    {
                        if(!$wp_filesystem->exists($instFile))
                        {
                            smp_log_to_file('instFile file does not exist: ' . $instFile);
                        }
                        elseif(!$wp_filesystem->is_readable($instFile))
                        {
                            smp_log_to_file('instFile file does not exist: ' . $instFile);
                        }
                        else
                        {
                            smp_log_to_file('instFile file is in unknown state... : ' . $instFile);
                        }
                        return;
                    }
            }
            foreach($pin_me_arr as $pma)
            {
                if (isset($smp_options['posting_method']) && $smp_options['posting_method'] == 'cred')
                {
                    try {
                        
                        $bot = PinterestBot::create();
                        $ymp_Pinterest_Settings = get_option('ymp_Pinterest_Settings', false);
                        if(isset($ymp_Pinterest_Settings['proxy_list']) && $ymp_Pinterest_Settings['proxy_list'] != '')
                        {
                            $proxy_arr = explode(',', $ymp_Pinterest_Settings['proxy_list']);
                            $rand_proxy = $proxy_arr[array_rand($proxy_arr)]; 
                            if(trim($rand_proxy) != '')
                            {
                                $rand_proxy = explode(':', $rand_proxy);
                                if(isset($rand_proxy[3]))
                                {
                                    $bot->getHttpClient()->useProxy($rand_proxy[0], $rand_proxy[1], $rand_proxy[2] . ":" . $rand_proxy[3]);
                                }
                                elseif(isset($rand_proxy[1]))
                                {
                                    $bot->getHttpClient()->useProxy($rand_proxy[0], $rand_proxy[1]);
                                }
                            }
                        }
                        if(isset($smp_options['user_agent']) && $smp_options['user_agent'] != '')
                        {
                            $user_agent = $smp_options['user_agent'];
                        }
                        else
                        {
                            $user_agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36';
                        }
                        $options = [CURLOPT_USERAGENT => $user_agent];
                        $bot->getHttpClient()->setOptions($options);
                        $bot->auth->login($smp_options['user_name'], $smp_options['user_pass']);
                        if ($bot->user->isBanned()) {
                            smp_log_to_file( "Account has been banned!" );
                            return;
                        }
                        $boards = $bot->boards->forMe();
                        $boards = $boards[array_rand($boards)];
                        $boardId = $boards['id'];
                        $bot->pins->create($pma, $boardId, $post_template, $blogUrl);
                    }
                    catch(Exception $e)
                    {
                        smp_log_to_file('Exception in Pinterest direct login posting: ' . $e->getMessage());
                    }
                }
                else
                {
                        try {
                            $pinterest = new Pinterest($smp_options['app_id'], $smp_options['app_secret']);
                        } catch (Exception $e) {
                            smp_log_to_file ('Authorisation error on Pinterest ' . $e->getMessage());
                            return;
                        }
                        try {
                            $pinterest->auth->setOAuthToken($access_token);
                            if(isset($smp_Pinterest_Settings['single_random']) && $smp_Pinterest_Settings['single_random'] == 'on')
                            {
                                $selecte_board = $smp_Pinterest_Settings['board_select'][array_rand($smp_Pinterest_Settings['board_select'])];
                                try {
                                    $pinterest->pins->create(array(
                                        "note"          => $post_template,
                                        "image_url"     => $pma,
                                        "board"         => $selecte_board,
                                        "link"          => $blogUrl
                                    ));
                                } catch (Exception $e) {
                                    smp_log_to_file("Exception while posting media to Pinterest for board ID: " . $selecte_board . ', error: ' . $e->getMessage());
                                }
                                $limit = $pinterest->getRateLimitRemaining();
                                if($limit === 0)
                                {
                                    smp_log_to_file("You are allowed to post a maximum of 200 pins each hour. You exceeded this limit, please slow down.");
                                    throw new Exception('Posting too fast!');
                                }
                            }
                            else
                            {
                                foreach($smp_Pinterest_Settings['board_select'] as $selecte_board)
                                {
                                    try {
                                        $pinterest->pins->create(array(
                                            "note"          => $post_template,
                                            "image_url"     => $pma,
                                            "board"         => $selecte_board,
                                            "link"          => $blogUrl
                                        ));
                                    } catch (Exception $e) {
                                        smp_log_to_file("Exception while posting media to Pinterest for board ID: " . $selecte_board . ', error: ' . $e->getMessage());
                                    }
                                    $limit = $pinterest->getRateLimitRemaining();
                                    if($limit === 0)
                                    {
                                        smp_log_to_file("You are allowed to post a maximum of 200 pins each hour. You exceeded this limit, please slow down.");
                                        throw new Exception('Posting too fast!');
                                    }
                                }
                            }
                        } 
                        catch (Exception $e) 
                        {
                        } 
                }
            }
        }
}

function smp_get_images($html_string, $get_attrs = FALSE)
{
    $post_images = array();
    preg_match_all('/<img (.+?)>/', $html_string, $image_matches, PREG_SET_ORDER);
    foreach ($image_matches as $image_match)
    {
        $post_image = new stdClass();
        $post_image->html = $image_match[0];
        if ($get_attrs == TRUE)
        {
            preg_match_all('/\s+?(.+)="([^"]*)"/U', $image_match[0], $image_attr_matches, PREG_SET_ORDER);
            
            foreach ($image_attr_matches as $image_attr)
            {
                if(isset($image_attr[1]) && isset($image_attr[2]))
                {
                    $post_image->attr->{$image_attr[1]} = $image_attr[2];
                }
            }
        }
        $post_images[] = $post_image;
        unset($post_image);
    }
    return $post_images;
}

function smp_preg_grep_keys( $pattern, $input, $flags = 0 )
{
    if(!is_array($input))
    {
        return array();
    }
    $keys = preg_grep( $pattern, array_keys( $input ), $flags );
    $vals = array();
    foreach ( $keys as $key )
    {
        $vals[$key] = $input[$key];
    }
    return $vals;
}

function smp_replacePinterestPostShortcodes($content, $post_link, $post_title, $blog_title, $post_excerpt, $post_content, $user_name, $featured_image, $post_cats, $post_tagz, $query_hashtags)
{
    $matches = array();
    $i = 0;
    preg_match_all('~%regex\(\s*\"([^"]+?)\s*"\s*[,;]\s*\"([^"]*)\"\s*(?:[,;]\s*\"([^"]*?)\s*\")?(?:[,;]\s*\"([^"]*?)\s*\")?(?:[,;]\s*\"([^"]*?)\s*\")?\)%~si', $content, $matches);
    if (is_array($matches) && count($matches) && is_array($matches[0])) {
        for($i = 0; $i < count($matches[0]); $i++)
        {
            if (isset($matches[0][$i])) $fullmatch = $matches[0][$i];
            if (isset($matches[1][$i])) $search_in = smp_replacePinterestPostShortcodes($matches[1][$i], $post_link, $post_title, $blog_title, $post_excerpt, $post_content, $user_name, $featured_image, $post_cats, $post_tagz, $query_hashtags);
            if (isset($matches[2][$i])) $matchpattern = $matches[2][$i];
            if (isset($matches[3][$i])) $element = $matches[3][$i];
            if (isset($matches[4][$i])) $delimeter = $matches[4][$i];if (isset($matches[5][$i])) $counter = $matches[5][$i];
            if (isset($matchpattern)) {
               if (preg_match('<^[\/#%+~[\]{}][\s\S]*[\/#%+~[\]{}]$>', $matchpattern, $z)) {
                  $ret = preg_match_all($matchpattern, $search_in, $submatches, PREG_PATTERN_ORDER);
               }
               else {
                  $ret = preg_match_all('~'.$matchpattern.'~si', $search_in, $submatches, PREG_PATTERN_ORDER);
               }
            }
            if (isset($submatches)) {
               if (is_array($submatches)) {
                  $empty_elements = array_keys($submatches[0], "");
                  foreach ($empty_elements as $e) {
                     unset($submatches[0][$e]);
                  }
                  $submatches[0] = array_unique($submatches[0]);
                  if (!is_numeric($element)) {
                     $element = 0;
                  }if (!is_numeric($counter)) {
                     $counter = 0;
                  }
                  if(isset($submatches[(int)($element)]))
                  {
                      $matched = $submatches[(int)($element)];
                  }
                  else
                  {
                      $matched = '';
                  }
                  $matched = array_unique((array)$matched);
                  if (empty($delimeter) || $delimeter == 'null') {
                     if (isset($matched[$counter])) $matched = $matched[$counter];
                  }
                  else {
                     $matched = implode($delimeter, $matched);
                  }
                  if (empty($matched)) {
                     $content = str_replace($fullmatch, '', $content);
                  } else {
                     $content = str_replace($fullmatch, $matched, $content);
                  }
               }
            }
        }
    }
    $spintax = new Smp_Spintax();
    $content = $spintax->Parse($content);
    $pcxxx = explode('<!- template ->', $content);
    $content = $pcxxx[array_rand($pcxxx)];
    $content = str_replace('%%post_link%%', $post_link, $content);
    $content = str_replace('%%post_title%%', $post_title, $content);
    $content = str_replace('%%blog_title%%', $blog_title, $content);
    $content = str_replace('%%post_excerpt%%', $post_excerpt, $content);
    $content = str_replace('%%post_content%%', $post_content, $content);
    $content = str_replace('%%author_name%%', $user_name, $content);
    $content = str_replace('%%featured_image%%', $featured_image, $content);
    $content = str_replace('%%post_cats%%', $post_cats, $content);
    $content = str_replace('%%post_tags%%', $post_tagz, $content);
    $content = str_replace('%%image_search_hashtags%%', $query_hashtags, $content);
    return $content;
}
class Smp_Spintax {
    static $countBlocks = 0;
    static $blocks = [];
    public static function Parse($text, $count = [])
    {
        if (strpos($text, '#block#') !== false) {
            $text = stripslashes(preg_replace_callback('|#block#(.*?)#/block#|si', ['Smp_Spintax', 'replaceBlock'], $text));
            $newBlocks = self::$blocks;
            shuffle($newBlocks);
            $count_from = $count_to = 0;
            if (!empty($count)) {
                $count_from = (int) $count[0] > 0 ? (int) $count[0] : 1;
                $count_to = ((int) $count[1] == 0 || (int) $count[1] > count($newBlocks)) ? count($newBlocks) : (int) $count[1];
            }
            $cntBlocks = rand($count_from, $count_to);
            $cntBlocks = ($cntBlocks == 0 || $cntBlocks > count($newBlocks)) ? count($newBlocks) : $cntBlocks;
            for ($i = 0; $i < $cntBlocks; $i++) {
                $p = implode("</p><p>", $newBlocks[$i]);
                $p = str_replace('<br />', '', $p);
                $p = '<p>' . $p . '</p>';
                $text = str_replace('{#block' . ($i + 1) . '#}', $p, $text);
            }
            $text = stripslashes(preg_replace('|{#block.*?#}|si', '', $text));
            self::$countBlocks = 0;
            self::$blocks = array();
        }
        $text = str_replace('</p><br />', '</p>', $text);
        $final = preg_replace('#(<br \/>\n*)+$#', '', self::process($text));
        return $final;
    }
    public static function replaceBlock($text)
    {
        if (!empty($text[1])) {
            preg_match_all('|#p#(.*?)#/p#|si', $text[1], $matches);
            if (!empty($matches[1])) {
                $p = $matches[1];
                shuffle($p);
                foreach ($p AS $key => $val) {
                    if (empty($val)) continue;
                    $test = explode('#s#', $val);
                    $index = array_rand($test, 1);
                    $test = $test[$index];
                    $test = explode("\n", $test);
                    shuffle($test);
                    $text = implode("</p><p>", $test);
                    $text = '<p>'. $text . '</p>';
                    self::$blocks[self::$countBlocks][] = $text;
                }
            } else {
                self::$blocks[self::$countBlocks][] = trim($text[1]);
            }
        }
        self::$countBlocks++;
        return '{#block' . self::$countBlocks . '#}';
    }
    public static function process($text)
    {
        $pattern = '/\{(((?>[^\{\}]+)|(?R))*)\}/x';
        return preg_replace_callback($pattern, ['Smp_Spintax', 'replace'], $text);
    }
    public static function replace($text)
    {
        $text = self::process($text[1]);
        $parts = explode('|', $text);
        return $parts[array_rand($parts)];
    }
}

class Smp_keywords{ 
    public static $charset = 'UTF-8';
    public static $banned_words = array('adsbygoogle', 'able', 'about', 'above', 'act', 'add', 'afraid', 'after', 'again', 'against', 'age', 'ago', 'agree', 'all', 'almost', 'alone', 'along', 'already', 'also', 'although', 'always', 'am', 'amount', 'an', 'and', 'anger', 'angry', 'animal', 'another', 'answer', 'any', 'appear', 'apple', 'are', 'arrive', 'arm', 'arms', 'around', 'arrive', 'as', 'ask', 'at', 'attempt', 'aunt', 'away', 'back', 'bad', 'bag', 'bay', 'be', 'became', 'because', 'become', 'been', 'before', 'began', 'begin', 'behind', 'being', 'bell', 'belong', 'below', 'beside', 'best', 'better', 'between', 'beyond', 'big', 'body', 'bone', 'born', 'borrow', 'both', 'bottom', 'box', 'boy', 'break', 'bring', 'brought', 'bug', 'built', 'busy', 'but', 'buy', 'by', 'call', 'came', 'can', 'cause', 'choose', 'close', 'close', 'consider', 'come', 'consider', 'considerable', 'contain', 'continue', 'could', 'cry', 'cut', 'dare', 'dark', 'deal', 'dear', 'decide', 'deep', 'did', 'die', 'do', 'does', 'dog', 'done', 'doubt', 'down', 'during', 'each', 'ear', 'early', 'eat', 'effort', 'either', 'else', 'end', 'enjoy', 'enough', 'enter', 'even', 'ever', 'every', 'except', 'expect', 'explain', 'fail', 'fall', 'far', 'fat', 'favor', 'fear', 'feel', 'feet', 'fell', 'felt', 'few', 'fill', 'find', 'fit', 'fly', 'follow', 'for', 'forever', 'forget', 'from', 'front', 'gave', 'get', 'gives', 'goes', 'gone', 'good', 'got', 'gray', 'great', 'green', 'grew', 'grow', 'guess', 'had', 'half', 'hang', 'happen', 'has', 'hat', 'have', 'he', 'hear', 'heard', 'held', 'hello', 'help', 'her', 'here', 'hers', 'high', 'hill', 'him', 'his', 'hit', 'hold', 'hot', 'how', 'however', 'I', 'if', 'ill', 'in', 'indeed', 'instead', 'into', 'iron', 'is', 'it', 'its', 'just', 'keep', 'kept', 'knew', 'know', 'known', 'late', 'least', 'led', 'left', 'lend', 'less', 'let', 'like', 'likely', 'likr', 'lone', 'long', 'look', 'lot', 'make', 'many', 'may', 'me', 'mean', 'met', 'might', 'mile', 'mine', 'moon', 'more', 'most', 'move', 'much', 'must', 'my', 'near', 'nearly', 'necessary', 'neither', 'never', 'next', 'no', 'none', 'nor', 'not', 'note', 'nothing', 'now', 'number', 'of', 'off', 'often', 'oh', 'on', 'once', 'only', 'or', 'other', 'ought', 'our', 'out', 'please', 'prepare', 'probable', 'pull', 'pure', 'push', 'put', 'raise', 'ran', 'rather', 'reach', 'realize', 'reply', 'require', 'rest', 'run', 'said', 'same', 'sat', 'saw', 'say', 'see', 'seem', 'seen', 'self', 'sell', 'sent', 'separate', 'set', 'shall', 'she', 'should', 'side', 'sign', 'since', 'so', 'sold', 'some', 'soon', 'sorry', 'stay', 'step', 'stick', 'still', 'stood', 'such', 'sudden', 'suppose', 'take', 'taken', 'talk', 'tall', 'tell', 'ten', 'than', 'thank', 'that', 'the', 'their', 'them', 'then', 'there', 'therefore', 'these', 'they', 'this', 'those', 'though', 'through', 'till', 'to', 'today', 'told', 'tomorrow', 'too', 'took', 'tore', 'tought', 'toward', 'tried', 'tries', 'trust', 'try', 'turn', 'two', 'under', 'until', 'up', 'upon', 'us', 'use', 'usual', 'various', 'verb', 'very', 'visit', 'want', 'was', 'we', 'well', 'went', 'were', 'what', 'when', 'where', 'whether', 'which', 'while', 'white', 'who', 'whom', 'whose', 'why', 'will', 'with', 'within', 'without', 'would', 'yes', 'yet', 'you', 'young', 'your', 'br', 'img', 'p','lt', 'gt', 'quot', 'copy');
    public static $min_word_length = 3;
    
    public static function text($text, $length = 160)
    {
        return self::limit_chars(self::clean($text), $length,'',TRUE);
    } 

    public static function keywords($text, $max_keys = 3, $shortest = false)
    {
        include (dirname(__FILE__) . "/res/diacritics.php");
        $wordcount = array_count_values(str_word_count(self::clean($text), 1, $diacritics));
        foreach ($wordcount as $key => $value) 
        {
            if ( (strlen($key)<= self::$min_word_length) OR in_array($key, self::$banned_words))
                unset($wordcount[$key]);
        }
        uasort($wordcount,[self::class, 'cmp']);
        if($shortest == true)
        {
            $wordcount = array_slice($wordcount, -1*$max_keys, $max_keys);
        }
        else
        {
            $wordcount = array_slice($wordcount, 0, $max_keys);
        }
        return implode(' ', array_keys($wordcount));
    } 

    private static function clean($text)
    { 
        $text = html_entity_decode($text,ENT_QUOTES,self::$charset);
        $text = strip_tags($text);
        $text = preg_replace('/\s\s+/', ' ', $text);
        $text = str_replace (array('\r\n', '\n', '+'), ',', $text);
        return trim($text); 
    } 

    private static function cmp($a, $b) 
    {
        if ($a == $b) return 0; 

        return ($a < $b) ? 1 : -1; 
    } 

    private static function limit_chars($str, $limit = 100, $end_char = NULL, $preserve_words = FALSE)
    {
        $end_char = ($end_char === NULL) ? '&#8230;' : $end_char;
        $limit = (int) $limit;
        if (trim($str) === '' OR strlen($str) <= $limit)
            return $str;
        if ($limit <= 0)
            return $end_char;
        if ($preserve_words === FALSE)
            return rtrim(substr($str, 0, $limit)).$end_char;
        if ( ! preg_match('/^.{0,'.$limit.'}\s/us', $str, $matches))
            return $end_char;
        return rtrim($matches[0]).((strlen($matches[0]) === strlen($str)) ? '' : $end_char);
    }
} 
function smp_get_pixabay_image($app_id, $query, $lang, $image_type, $orientation, $order, $image_category, $max_width, $min_width, $safe_search, $editors_choice, &$original_url, $get_max = 3, $rand_page = false, $disablecache = false)
{
    $original_url = 'https://pixabay.com';
    $featured_image = '';
    $feed_uri = 'https://pixabay.com/api/?key=' . $app_id;
    if($query != '')
    {
        $feed_uri .= '&q=' . urlencode($query);
    }
    $feed_uri .= '&per_page=' . $get_max;
    if($lang != '' && $lang != 'any')
    {
        $feed_uri .= '&lang=' . $lang;
    }
    if($image_type != '')
    {
        $feed_uri .= '&image_type=' . $image_type;
    }
    if($orientation != '')
    {
        $feed_uri .= '&orientation=' . $orientation;
    }
    if($order != '')
    {
        $feed_uri .= '&order=' . $order;
    }
    if($image_category != '')
    {
        $feed_uri .= '&category=' . $image_category;
    }
    if($max_width != '')
    {
        $feed_uri .= '&max_width=' . $max_width;
    }
    if($min_width != '')
    {
        $feed_uri .= '&min_width=' . $min_width;
    }
    if($safe_search == '1')
    {
        $feed_uri .= '&safesearch=true';
    }
    if($editors_choice == '1')
    {
        $feed_uri .= '&editors_choice=true';
    }
    if($rand_page == true)
    {
        $page = array(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
        $feed_uri .= '&page=' . $page[array_rand($page)];
    }
    if($disablecache != true)
    {
        $q = array();
        $q['feed_uri'] = $feed_uri;
        $existing = smp_get_items($q);
    }
    else
    {
        $existing = array();
    }
    if(isset($existing[0]->feed_response))
    {
        $exec = $existing[0]->feed_response;
    }
    else
    {
        $exec = smp_get_web_page($feed_uri);
    }
    if ($exec !== FALSE) 
    {
        if (stristr($exec, '"hits"') !== FALSE) 
        {
            $json  = json_decode($exec);
            $items = $json->hits;
            if (count($items) != 0) 
            {
                if($disablecache != true)
                {
                    $post = array();
                    $post['feed_uri'] = $feed_uri;
                    $post['feed_response'] = $exec;
                    $ret = smp_insert_item($post); 
                    if($ret === false || $ret === 0)
                    {
                        smp_log_to_file('Failed to insert post into custom database(1)! ' . $feed_uri);
                    }
                }
                $GLOBALS['wp_object_cache']->delete('smp_posted_imgs', 'options');
                $already_posted = get_option('smp_posted_imgs', array());
                shuffle($items);
                foreach($items as $item)
                {
                    $featured_image = $item->webformatURL;
                    
                    if(!in_array($featured_image, $already_posted))
                    {
                        $original_url = $item->pageURL;
                        $already_posted[] = $featured_image;
                        update_option('smp_posted_imgs', $already_posted);
                        break;
                    }
                    else
                    {
                        $featured_image = '';
                    }
                }
            }
        }
        else
        {
            smp_log_to_file('Unknow response from api: ' . $feed_uri . ' - resp: ' . $exec);
        }
    }
    else
    {
        smp_log_to_file('Error while getting api url: ' . $feed_uri);
        return false;
    }
    return $featured_image;
}
function smp_scrape_pixabay_image($smp_options, $query, &$original_url, $rand_page, $disablecache)
{
    $original_url = 'https://pixabay.com';
    $featured_image = '';
    $feed_uri = 'https://pixabay.com/en/photos/';
    if($query != '')
    {
        $feed_uri .= '?q=' . urlencode($query);
    }

    if($smp_options['scrapeimgtype'] != 'all')
    {
        $feed_uri .= '&image_type=' . $smp_options['scrapeimgtype'];
    }
    if($smp_options['scrapeimg_orientation'] != '')
    {
        $feed_uri .= '&orientation=' . $smp_options['scrapeimg_orientation'];
    }
    if($smp_options['scrapeimg_order'] != '' && $smp_options['scrapeimg_order'] != 'any')
    {
        $feed_uri .= '&order=' . $smp_options['scrapeimg_order'];
    }
    if($smp_options['scrapeimg_cat'] != '')
    {
        $feed_uri .= '&category=' . $smp_options['scrapeimg_cat'];
    }
    if($smp_options['scrapeimg_height'] != '')
    {
        $feed_uri .= '&min_height=' . $smp_options['scrapeimg_height'];
    }
    if($smp_options['scrapeimg_width'] != '')
    {
        $feed_uri .= '&min_width=' . $smp_options['scrapeimg_width'];
    }
    if($disablecache != true)
    {
        $q = array();
        $q['feed_uri'] = $feed_uri;
        $existing = smp_get_items($q);
    }
    else
    {
        $existing = array();
    }
    if(isset($existing[0]->feed_response))
    {
        $exec = $existing[0]->feed_response;
    }
    else
    {
        $exec = smp_get_web_page($feed_uri);
    }
    if ($exec !== FALSE) 
    {
        preg_match_all('/<a href="([^"]+?)".+?(?:data-lazy|src)="([^"]+?\.jpg|png)"/i', $exec, $matches);
        if (!empty($matches[2])) {
            $p = array_combine($matches[1], $matches[2]);
            if(count($p) > 0)
            {
                if($disablecache != true)
                {
                    $post = array();
                    $post['feed_uri'] = $feed_uri;
                    $post['feed_response'] = $exec;
                    $ret = smp_insert_item($post); 
                    if($ret === false || $ret === 0)
                    {
                        smp_log_to_file('Failed to insert post into custom database(1)! ' . $feed_uri);
                    }
                }
                $GLOBALS['wp_object_cache']->delete('smp_posted_imgs', 'options');
                $already_posted = get_option('smp_posted_imgs', array());
                shuffle($p);
                foreach ($p as $key => $val) {
                    $featured_image = $val;
                    if(!is_numeric($key))
                    {
                        if(substr($key, 0, 4) !== "http")
                        {
                            $key = 'https://pixabay.com' . $key;
                        }
                    }
                    else
                    {
                        $key = 'https://pixabay.com';
                    }
                    if(!in_array($featured_image, $already_posted))
                    {
                        $original_url = $key;
                        $already_posted[] = $featured_image;
                        update_option('smp_posted_imgs', $already_posted);
                        break;
                    }
                    else
                    {
                        $featured_image = '';
                    }
                }
            }
        }
    }
    else
    {
        smp_log_to_file('Error while getting api url: ' . $feed_uri);
        return false;
    }
    return $featured_image;
}
function smp_get_morguefile_image($app_id, $app_secret, $query, &$original_url, $rand_page, $disablecache)
{
    $featured_image = '';
    if(!class_exists('smp_morguefile'))
    {
        require_once (dirname(__FILE__) . "/morguefile/mf.api.class.php");
    }
    $query = explode(' ', $query);
    $query = $query[0];
    if($disablecache != true)
    {
        $q = array();
        $q['feed_uri'] = 'morgue_' . $query;
        $existing = smp_get_items($q);
    }
    else
    {
        $existing = array();
    }
    if(isset($existing[0]->feed_response))
    {
        return $existing[0]->feed_response;
    }
    else
    {
        $mf = new smp_morguefile($app_id, $app_secret);
        $rez = $mf->call('/images/search/sort/page/' . $query);
        if ($rez !== FALSE) 
        {
            if($rand_page == true)
            {
                $chosen_one = $rez->doc[array_rand($rez->doc)];
            }
            else
            {
                $chosen_one = $rez->doc[0];
            }
            if (isset($chosen_one->file_path_large)) 
            {
                $GLOBALS['wp_object_cache']->delete('smp_posted_imgs', 'options');
                $already_posted = get_option('smp_posted_imgs', array());
                if(!in_array($chosen_one->file_path_large, $already_posted))
                {
                    if($disablecache != true)
                    {
                        $post = array();
                        $post['feed_uri'] = 'morgue_' . $query;
                        $post['feed_response'] = $chosen_one->file_path_large;
                        $ret = smp_insert_item($post); 
                        if($ret === false || $ret === 0)
                        {
                            smp_log_to_file('Failed to insert post into custom database(2)! ' . $feed_uri);
                        }
                    }
                    $already_posted[] = $chosen_one->file_path_large;
                    update_option('smp_posted_imgs', $already_posted);
                    return $chosen_one->file_path_large;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        else
        {
            smp_log_to_file('Error while getting api response from morguefile.');
            return false;
        }
    }
    return $featured_image;
}
function smp_get_flickr_image($smp_options, $query, &$original_url, $max, $rand_page, $disablecache)
{
    $original_url = 'https://www.flickr.com';
    $featured_image = '';
    $GLOBALS['wp_object_cache']->delete('smp_posted_imgs', 'options');
    $already_posted = get_option('smp_posted_imgs', array());
    $feed_uri = 'https://api.flickr.com/services/rest/?method=flickr.photos.search&api_key=' . $smp_options['flickr_api'] . '&media=photos&per_page=' . esc_html($max) . '&format=php_serial&text=' . urlencode($query);
    if(isset($smp_options['flickr_license']) && $smp_options['flickr_license'] != '-1')
    {
        $feed_uri .= '&license=' . $smp_options['flickr_license'];
    }
    if(isset($smp_options['flickr_order']) && $smp_options['flickr_order'] != '')
    {
        $feed_uri .= '&sort=' . $smp_options['flickr_order'];
    }
    $feed_uri .= '&extras=description,license,date_upload,date_taken,owner_name,icon_server,original_format,last_update,geo,tags,machine_tags,o_dims,views,media,path_alias,url_sq,url_t,url_s,url_q,url_m,url_n,url_z,url_c,url_l,url_o';
    if($rand_page == true)
    {
        $page = array(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
        $feed_uri .= '&page=' . $page[array_rand($page)];
    }
    if($disablecache != true)
    {
        $q = array();
        $q['feed_uri'] = $feed_uri;
        $existing = smp_get_items($q);
    }
    else
    {
        $existing = array();
    }
    if(isset($existing[0]->feed_response))
    {
        return $existing[0]->feed_response;
    }
    else
    {
        $ch               = curl_init();
        if ($ch === FALSE) {
            smp_log_to_file('Failed to init curl for flickr!');
            return false;
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Referer: https://www.flickr.com/'));
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_HTTPGET, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_URL, $feed_uri);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $exec = curl_exec($ch);
        curl_close($ch);
        if (stristr($exec, 'photos') === FALSE) {
            smp_log_to_file('Unrecognized API response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        $items = unserialize ( $exec );
        if(!isset($items['photos']['photo']))
        {
            smp_log_to_file('Failed to find photo node in response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        if(count($items['photos']['photo']) == 0)
        {
            return $featured_image;
        }
        $x = 0;
        shuffle($items['photos']['photo']);
        while($featured_image == '' && isset($items['photos']['photo'][$x]))
        {
            $item = $items['photos']['photo'][$x];
            if(isset($item['url_o']))
            {
                $featured_image = $item['url_o'];
            }
            elseif(isset($item['url_l']))
            {
                $featured_image = $item['url_l'];
            }
            elseif(isset($item['url_c']))
            {
                $featured_image = $item['url_c'];
            }
            elseif(isset($item['url_z']))
            {
                $featured_image = $item['url_z'];
            }
            elseif(isset($item['url_n']))
            {
                $featured_image = $item['url_n'];
            }
            elseif(isset($item['url_m']))
            {
                $featured_image = $item['url_m'];
            }
            elseif(isset($item['url_q']))
            {
                $featured_image = $item['url_q'];
            }
            elseif(isset($item['url_s']))
            {
                $featured_image = $item['url_s'];
            }
            elseif(isset($item['url_t']))
            {
                $featured_image = $item['url_t'];
            }
            elseif(isset($item['url_sq']))
            {
                $featured_image = $item['url_sq'];
            }
            if($featured_image != '')
            {
                if(!in_array($featured_image, $already_posted))
                {
                    $already_posted[] = $featured_image;
                    update_option('smp_posted_imgs', $already_posted);
                    $original_url = esc_url_raw('https://www.flickr.com/photos/' . $item['owner'] . '/' . $item['id']);
                    if($disablecache != true)
                    {
                        $post = array();
                        $post['feed_uri'] = $feed_uri;
                        $post['feed_response'] = $featured_image;
                        $ret = smp_insert_item($post); 
                        if($ret === false || $ret === 0)
                        {
                            smp_log_to_file('Failed to insert post into custom database{3}! ' . $feed_uri);
                        }
                    }
                }
                else
                {
                    $featured_image = '';
                }
            }
            $x++;
        }
    }
    return $featured_image;
}
function smp_get_pexels_image($smp_options, $query, &$original_url, $max, $rand_page, $disablecache)
{
    $original_url = 'https://pexels.com';
    $featured_image = '';
    $GLOBALS['wp_object_cache']->delete('smp_posted_imgs', 'options');
    $already_posted = get_option('smp_posted_imgs', array());
    $feed_uri = 'https://api.pexels.com/v1/search?query=' . urlencode($query) . '&per_page=' . $max;
    if($rand_page == true)
    {
        $page = array(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
        $feed_uri .= '&page=' . $page[array_rand($page)];
    }
    if($disablecache != true)
    {
        $q = array();
        $q['feed_uri'] = $feed_uri;
        $existing = smp_get_items($q);
    }
    else
    {
        $existing = array();
    }
    if(isset($existing[0]->feed_response))
    {
        return $existing[0]->feed_response;
    }
    else
    {
        $ch               = curl_init();
        if ($ch === FALSE) {
            smp_log_to_file('Failed to init curl for flickr!');
            return false;
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: ' . $smp_options['pexels_api']));
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_HTTPGET, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_URL, $feed_uri);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $exec = curl_exec($ch);
        curl_close($ch);
        if (stristr($exec, 'photos') === FALSE) {
            smp_log_to_file('Unrecognized Pexels API response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        $items = json_decode ( $exec, true );
        if(!isset($items['photos']))
        {
            smp_log_to_file('Failed to find photo node in Pexels response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        if(count($items['photos']) == 0)
        {
            return $featured_image;
        }
        $x = 0;
        shuffle($items['photos']);
        while($featured_image == '' && isset($items['photos'][$x]))
        {
            $item = $items['photos'][$x];
            if(isset($item['src']['large']))
            {
                $featured_image = $item['src']['large'];
            }
            elseif(isset($item['src']['medium']))
            {
                $featured_image = $item['src']['medium'];
            }
            elseif(isset($item['src']['small']))
            {
                $featured_image = $item['src']['small'];
            }
            elseif(isset($item['src']['portrait']))
            {
                $featured_image = $item['src']['portrait'];
            }
            elseif(isset($item['src']['landscape']))
            {
                $featured_image = $item['src']['landscape'];
            }
            elseif(isset($item['src']['original']))
            {
                $featured_image = $item['src']['original'];
            }
            elseif(isset($item['src']['tiny']))
            {
                $featured_image = $item['src']['tiny'];
            }
            if($featured_image != '')
            {
                if(!in_array($featured_image, $already_posted))
                {
                    $already_posted[] = $featured_image;
                    update_option('smp_posted_imgs', $already_posted);
                    $original_url = $item['url'];
                    if($disablecache != true)
                    {
                        $post = array();
                        $post['feed_uri'] = $feed_uri;
                        $post['feed_response'] = $featured_image;
                        $ret = smp_insert_item($post); 
                        if($ret === false || $ret === 0)
                        {
                            smp_log_to_file('Failed to insert post into custom database{3}! ' . $feed_uri);
                        }
                    }
                }
                else
                {
                    $featured_image = '';
                }
            }
            $x++;
        }
    }
    return $featured_image;
}
function smp_get_web_page($url)
{
    $content = false;
    $args = array(
       'timeout'     => 120,
       'redirection' => 10,
       'user-agent'  => smp_get_random_user_agent(),
       'blocking'    => true,
       'headers'     => array(),
       'cookies'     => array(),
       'body'        => null,
       'compress'    => false,
       'decompress'  => true,
       'sslverify'   => false,
       'stream'      => false,
       'filename'    => null
    );
    $ret_data            = wp_remote_get(html_entity_decode($url), $args);  
    $response_code       = wp_remote_retrieve_response_code( $ret_data );
    $response_message    = wp_remote_retrieve_response_message( $ret_data );        
    if ( 200 != $response_code ) {
    } else {
        $content = wp_remote_retrieve_body( $ret_data );
    }
    if($content === false)
    {
        if(function_exists('curl_version') && filter_var($url, FILTER_VALIDATE_URL))
        {
            $user_agent = smp_get_random_user_agent();
            $options    = array(
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_POST => false,
                CURLOPT_USERAGENT => $user_agent,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_HEADER => false,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_ENCODING => "",
                CURLOPT_AUTOREFERER => true,
                CURLOPT_CONNECTTIMEOUT => 10,
                CURLOPT_TIMEOUT => 120,
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_REFERER => get_site_url(),
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0
            );
            $ch         = curl_init($url);
            if ($ch === FALSE) {
                return FALSE;
            }
            curl_setopt_array($ch, $options);
            $content = curl_exec($ch);
            curl_close($ch);
        }
        else
        {
            $allowUrlFopen = preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen'));
            if ($allowUrlFopen) {
                global $wp_filesystem;
                if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                    include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                    wp_filesystem($creds);
                }
                return $wp_filesystem->get_contents($url);
            }
        }
    }
    return $content;
}
function smp_getUrls($string) {
    $regex = '/https?\:\/\/[^\"\' \n\s]+/i';
    preg_match_all($regex, $string, $matches);
    return ($matches[0]);
}
function smp_endsWith($haystack, $needle)
{
    $length = strlen($needle);
    if ($length == 0) {
        return true;
    }

    return (substr($haystack, -$length) === $needle);
}
function smp_generate_featured_image($image_url, $post_id)
{
    $upload_dir = wp_upload_dir();
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $image_data = $wp_filesystem->get_contents($image_url);
    if ($image_data === FALSE || empty($image_data)) {
        $image_data = smp_get_web_page($image_url);
        if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE || strpos($image_data, '<title>Just a moment...</title>') !== FALSE) {
            return false;
        }
    }
    $filename = basename($image_url);
    $temp     = explode("?", $filename);
    $filename = $temp[0];
    $filename = str_replace('%', '-', $filename);
    $filename = str_replace('#', '-', $filename);
    $filename = str_replace('&', '-', $filename);
    $filename = str_replace('{', '-', $filename);
    $filename = str_replace('}', '-', $filename);
    $filename = str_replace('\\', '-', $filename);
    $filename = str_replace('<', '-', $filename);
    $filename = str_replace('>', '-', $filename);
    $filename = str_replace('*', '-', $filename);
    $filename = str_replace('/', '-', $filename);
    $filename = str_replace('$', '-', $filename);
    $filename = str_replace('\'', '-', $filename);
    $filename = str_replace('"', '-', $filename);
    $filename = str_replace(':', '-', $filename);
    $filename = str_replace('@', '-', $filename);
    $filename = str_replace('+', '-', $filename);
    $filename = str_replace('|', '-', $filename);
    $filename = str_replace('=', '-', $filename);
    $filename = str_replace('`', '-', $filename);
    $filename = stripslashes(preg_replace_callback('#(%[a-zA-Z0-9_]*)#', function($matches){ return rand(0, 9); }, preg_quote($filename)));
    $file_parts = pathinfo($filename);
    $post_title = get_the_title($post_id);
    if($post_title != '')
    {
        $post_title = remove_accents( $post_title );
        $invalid = array(
            ' '   => '-',
            '%20' => '-',
            '_'   => '-',
        );
        $post_title = str_replace( array_keys( $invalid ), array_values( $invalid ), $post_title );
        $post_title = preg_replace('/[\x{1F3F4}](?:\x{E0067}\x{E0062}\x{E0077}\x{E006C}\x{E0073}\x{E007F})|[\x{1F3F4}](?:\x{E0067}\x{E0062}\x{E0073}\x{E0063}\x{E0074}\x{E007F})|[\x{1F3F4}](?:\x{E0067}\x{E0062}\x{E0065}\x{E006E}\x{E0067}\x{E007F})|[\x{1F3F4}](?:\x{200D}\x{2620}\x{FE0F})|[\x{1F3F3}](?:\x{FE0F}\x{200D}\x{1F308})|[\x{0023}\x{002A}\x{0030}\x{0031}\x{0032}\x{0033}\x{0034}\x{0035}\x{0036}\x{0037}\x{0038}\x{0039}](?:\x{FE0F}\x{20E3})|[\x{1F415}](?:\x{200D}\x{1F9BA})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F467}\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F467}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F466}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F466})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F467}\x{200D}\x{1F467})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F466}\x{200D}\x{1F466})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F467}\x{200D}\x{1F466})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F467})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F467}\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F466}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F467}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F466})|[\x{1F469}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F469})|[\x{1F469}\x{1F468}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F468})|[\x{1F469}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F48B}\x{200D}\x{1F469})|[\x{1F469}\x{1F468}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F48B}\x{200D}\x{1F468})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9BD})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9BC})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9AF})|[\x{1F575}\x{1F3CC}\x{26F9}\x{1F3CB}](?:\x{FE0F}\x{200D}\x{2640}\x{FE0F})|[\x{1F575}\x{1F3CC}\x{26F9}\x{1F3CB}](?:\x{FE0F}\x{200D}\x{2642}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F692})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F680})|[\x{1F468}\x{1F469}](?:\x{200D}\x{2708}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3A8})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3A4})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F4BB})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F52C})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F4BC})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3ED})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F527})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F373})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F33E})|[\x{1F468}\x{1F469}](?:\x{200D}\x{2696}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3EB})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F393})|[\x{1F468}\x{1F469}](?:\x{200D}\x{2695}\x{FE0F})|[\x{1F471}\x{1F64D}\x{1F64E}\x{1F645}\x{1F646}\x{1F481}\x{1F64B}\x{1F9CF}\x{1F647}\x{1F926}\x{1F937}\x{1F46E}\x{1F482}\x{1F477}\x{1F473}\x{1F9B8}\x{1F9B9}\x{1F9D9}\x{1F9DA}\x{1F9DB}\x{1F9DC}\x{1F9DD}\x{1F9DE}\x{1F9DF}\x{1F486}\x{1F487}\x{1F6B6}\x{1F9CD}\x{1F9CE}\x{1F3C3}\x{1F46F}\x{1F9D6}\x{1F9D7}\x{1F3C4}\x{1F6A3}\x{1F3CA}\x{1F6B4}\x{1F6B5}\x{1F938}\x{1F93C}\x{1F93D}\x{1F93E}\x{1F939}\x{1F9D8}](?:\x{200D}\x{2640}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B2})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B3})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B1})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B0})|[\x{1F471}\x{1F64D}\x{1F64E}\x{1F645}\x{1F646}\x{1F481}\x{1F64B}\x{1F9CF}\x{1F647}\x{1F926}\x{1F937}\x{1F46E}\x{1F482}\x{1F477}\x{1F473}\x{1F9B8}\x{1F9B9}\x{1F9D9}\x{1F9DA}\x{1F9DB}\x{1F9DC}\x{1F9DD}\x{1F9DE}\x{1F9DF}\x{1F486}\x{1F487}\x{1F6B6}\x{1F9CD}\x{1F9CE}\x{1F3C3}\x{1F46F}\x{1F9D6}\x{1F9D7}\x{1F3C4}\x{1F6A3}\x{1F3CA}\x{1F6B4}\x{1F6B5}\x{1F938}\x{1F93C}\x{1F93D}\x{1F93E}\x{1F939}\x{1F9D8}](?:\x{200D}\x{2642}\x{FE0F})|[\x{1F441}](?:\x{FE0F}\x{200D}\x{1F5E8}\x{FE0F})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1F0}\x{1F1F2}\x{1F1F3}\x{1F1F8}\x{1F1F9}\x{1F1FA}](?:\x{1F1FF})|[\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1F0}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1FA}](?:\x{1F1FE})|[\x{1F1E6}\x{1F1E8}\x{1F1F2}\x{1F1F8}](?:\x{1F1FD})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1F0}\x{1F1F2}\x{1F1F5}\x{1F1F7}\x{1F1F9}\x{1F1FF}](?:\x{1F1FC})|[\x{1F1E7}\x{1F1E8}\x{1F1F1}\x{1F1F2}\x{1F1F8}\x{1F1F9}](?:\x{1F1FB})|[\x{1F1E6}\x{1F1E8}\x{1F1EA}\x{1F1EC}\x{1F1ED}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F7}\x{1F1FB}](?:\x{1F1FA})|[\x{1F1E6}\x{1F1E7}\x{1F1EA}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FE}](?:\x{1F1F9})|[\x{1F1E6}\x{1F1E7}\x{1F1EA}\x{1F1EC}\x{1F1EE}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F7}\x{1F1F8}\x{1F1FA}\x{1F1FC}](?:\x{1F1F8})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EA}\x{1F1EB}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1F0}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F8}\x{1F1F9}](?:\x{1F1F7})|[\x{1F1E6}\x{1F1E7}\x{1F1EC}\x{1F1EE}\x{1F1F2}](?:\x{1F1F6})|[\x{1F1E8}\x{1F1EC}\x{1F1EF}\x{1F1F0}\x{1F1F2}\x{1F1F3}](?:\x{1F1F5})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1EB}\x{1F1EE}\x{1F1EF}\x{1F1F2}\x{1F1F3}\x{1F1F7}\x{1F1F8}\x{1F1F9}](?:\x{1F1F4})|[\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1F0}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FB}](?:\x{1F1F3})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1EB}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1EF}\x{1F1F0}\x{1F1F2}\x{1F1F4}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FF}](?:\x{1F1F2})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1EE}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F8}\x{1F1F9}](?:\x{1F1F1})|[\x{1F1E8}\x{1F1E9}\x{1F1EB}\x{1F1ED}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FD}](?:\x{1F1F0})|[\x{1F1E7}\x{1F1E9}\x{1F1EB}\x{1F1F8}\x{1F1F9}](?:\x{1F1EF})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EB}\x{1F1EC}\x{1F1F0}\x{1F1F1}\x{1F1F3}\x{1F1F8}\x{1F1FB}](?:\x{1F1EE})|[\x{1F1E7}\x{1F1E8}\x{1F1EA}\x{1F1EC}\x{1F1F0}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}](?:\x{1F1ED})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1EA}\x{1F1EC}\x{1F1F0}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FB}](?:\x{1F1EC})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F9}\x{1F1FC}](?:\x{1F1EB})|[\x{1F1E6}\x{1F1E7}\x{1F1E9}\x{1F1EA}\x{1F1EC}\x{1F1EE}\x{1F1EF}\x{1F1F0}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F7}\x{1F1F8}\x{1F1FB}\x{1F1FE}](?:\x{1F1EA})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1EE}\x{1F1F2}\x{1F1F8}\x{1F1F9}](?:\x{1F1E9})|[\x{1F1E6}\x{1F1E8}\x{1F1EA}\x{1F1EE}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F8}\x{1F1F9}\x{1F1FB}](?:\x{1F1E8})|[\x{1F1E7}\x{1F1EC}\x{1F1F1}\x{1F1F8}](?:\x{1F1E7})|[\x{1F1E7}\x{1F1E8}\x{1F1EA}\x{1F1EC}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F6}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FB}\x{1F1FF}](?:\x{1F1E6})|[\x{00A9}\x{00AE}\x{203C}\x{2049}\x{2122}\x{2139}\x{2194}-\x{2199}\x{21A9}-\x{21AA}\x{231A}-\x{231B}\x{2328}\x{23CF}\x{23E9}-\x{23F3}\x{23F8}-\x{23FA}\x{24C2}\x{25AA}-\x{25AB}\x{25B6}\x{25C0}\x{25FB}-\x{25FE}\x{2600}-\x{2604}\x{260E}\x{2611}\x{2614}-\x{2615}\x{2618}\x{261D}\x{2620}\x{2622}-\x{2623}\x{2626}\x{262A}\x{262E}-\x{262F}\x{2638}-\x{263A}\x{2640}\x{2642}\x{2648}-\x{2653}\x{265F}-\x{2660}\x{2663}\x{2665}-\x{2666}\x{2668}\x{267B}\x{267E}-\x{267F}\x{2692}-\x{2697}\x{2699}\x{269B}-\x{269C}\x{26A0}-\x{26A1}\x{26AA}-\x{26AB}\x{26B0}-\x{26B1}\x{26BD}-\x{26BE}\x{26C4}-\x{26C5}\x{26C8}\x{26CE}-\x{26CF}\x{26D1}\x{26D3}-\x{26D4}\x{26E9}-\x{26EA}\x{26F0}-\x{26F5}\x{26F7}-\x{26FA}\x{26FD}\x{2702}\x{2705}\x{2708}-\x{270D}\x{270F}\x{2712}\x{2714}\x{2716}\x{271D}\x{2721}\x{2728}\x{2733}-\x{2734}\x{2744}\x{2747}\x{274C}\x{274E}\x{2753}-\x{2755}\x{2757}\x{2763}-\x{2764}\x{2795}-\x{2797}\x{27A1}\x{27B0}\x{27BF}\x{2934}-\x{2935}\x{2B05}-\x{2B07}\x{2B1B}-\x{2B1C}\x{2B50}\x{2B55}\x{3030}\x{303D}\x{3297}\x{3299}\x{1F004}\x{1F0CF}\x{1F170}-\x{1F171}\x{1F17E}-\x{1F17F}\x{1F18E}\x{1F191}-\x{1F19A}\x{1F201}-\x{1F202}\x{1F21A}\x{1F22F}\x{1F232}-\x{1F23A}\x{1F250}-\x{1F251}\x{1F300}-\x{1F321}\x{1F324}-\x{1F393}\x{1F396}-\x{1F397}\x{1F399}-\x{1F39B}\x{1F39E}-\x{1F3F0}\x{1F3F3}-\x{1F3F5}\x{1F3F7}-\x{1F3FA}\x{1F400}-\x{1F4FD}\x{1F4FF}-\x{1F53D}\x{1F549}-\x{1F54E}\x{1F550}-\x{1F567}\x{1F56F}-\x{1F570}\x{1F573}-\x{1F57A}\x{1F587}\x{1F58A}-\x{1F58D}\x{1F590}\x{1F595}-\x{1F596}\x{1F5A4}-\x{1F5A5}\x{1F5A8}\x{1F5B1}-\x{1F5B2}\x{1F5BC}\x{1F5C2}-\x{1F5C4}\x{1F5D1}-\x{1F5D3}\x{1F5DC}-\x{1F5DE}\x{1F5E1}\x{1F5E3}\x{1F5E8}\x{1F5EF}\x{1F5F3}\x{1F5FA}-\x{1F64F}\x{1F680}-\x{1F6C5}\x{1F6CB}-\x{1F6D2}\x{1F6D5}\x{1F6E0}-\x{1F6E5}\x{1F6E9}\x{1F6EB}-\x{1F6EC}\x{1F6F0}\x{1F6F3}-\x{1F6FA}\x{1F7E0}-\x{1F7EB}\x{1F90D}-\x{1F93A}\x{1F93C}-\x{1F945}\x{1F947}-\x{1F971}\x{1F973}-\x{1F976}\x{1F97A}-\x{1F9A2}\x{1F9A5}-\x{1F9AA}\x{1F9AE}-\x{1F9CA}\x{1F9CD}-\x{1F9FF}\x{1FA70}-\x{1FA73}\x{1FA78}-\x{1FA7A}\x{1FA80}-\x{1FA82}\x{1FA90}-\x{1FA95}]/u', '', $post_title);
        
        $post_title = preg_replace('/\.(?=.*\.)/', '', $post_title);
        $post_title = preg_replace('/-+/', '-', $post_title);
        $post_title = str_replace('-.', '.', $post_title);
        $post_title = strtolower( $post_title );
        if($post_title == '')
        {
            $post_title = uniqid();
        }
        if(isset($file_parts['extension']))
        {
            switch($file_parts['extension'])
            {
                case "":
                $filename = sanitize_title($post_title) . '.jpg';
                break;
                case NULL:
                $filename = sanitize_title($post_title) . '.jpg';
                break;
                default:
                $filename = sanitize_title($post_title) . '.' . $file_parts['extension'];
                break;
            }
        }
        else
        {
            $filename = sanitize_title($post_title) . '.jpg';
        }
    }
    else
    {
        if(isset($file_parts['extension']))
        {
            switch($file_parts['extension'])
            {
                case "":
                if(!smp_endsWith($filename, '.jpg'))
                    $filename .= '.jpg';
                break;
                case NULL:
                if(!smp_endsWith($filename, '.jpg'))
                    $filename .= '.jpg';
                break;
                default:
                if(!smp_endsWith($filename, '.' . $file_parts['extension']))
                    $filename .= '.' . $file_parts['extension'];
                break;
            }
        }
        else
        {
            if(!smp_endsWith($filename, '.jpg'))
                $filename .= '.jpg';
        }
    }
    $filename = sanitize_file_name($filename);
    if (wp_mkdir_p($upload_dir['path']))
    {
        $file = $upload_dir['path'] . '/' . $post_id . '-' . $filename;
        $urls = $upload_dir['url'] . '/' . $post_id . '/' . $filename;
    }
    else
    {
        $file = $upload_dir['basedir'] . '/' . $post_id . '-' . $filename;
        $urls = $upload_dir['baseurl'] . '/' . $post_id . '/' . $filename;
    }
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $ret = $wp_filesystem->put_contents($file, $image_data);
    if ($ret === FALSE) {
        return false;
    }
    $smp_options = get_option('SMP_Options_General');
    if ((isset($smp_options['height']) && $smp_options['height'] !== '') || (isset($smp_options['width']) && $smp_options['width'] !== ''))
    {
        try
        {
            if(!class_exists('\Eventviva\ImageResize')){require_once (dirname(__FILE__) . "/ImageResize/ImageResize.php");}
            $imageRes = new ImageResize($file);
            $imageRes->quality_jpg = 100;
            if ((isset($smp_options['width']) && $smp_options['height'] !== '') && (isset($smp_options['width']) && $smp_options['width'] !== ''))
            {
                $imageRes->resizeToBestFit($smp_options['width'], $smp_options['height'], true);
            }
            elseif (isset($smp_options['width']) && $smp_options['width'] !== '')
            {
                $imageRes->resizeToWidth($smp_options['width'], true);
            }
            elseif (isset($smp_options['height']) && $smp_options['height'] !== '')
            {
                $imageRes->resizeToHeight($smp_options['height'], true);
            }
            $imageRes->save($file);
        }
        catch(Exception $e)
        {
            smp_log_to_file('Failed to resize featured image: ' . $image_url . ' to sizes ' . $smp_options['width'] . ' - ' . $smp_options['height'] . '. Exception thrown ' . esc_html($e->getMessage()) . '!');
        }
    }
    if (isset($smp_options['overlay_text']) && $smp_options['overlay_text'] !== '')
    {
        $png = imagecreatefrompng($smp_options['overlay_text']);
        if($png === false)
        {
            $png = imagecreatefromjpeg($smp_options['overlay_text']);
        }
        if($png !== false)
        {
            $jpeg = imagecreatefromjpeg($file);
            if($jpeg === false)
            {
                $jpeg = imagecreatefrompng($file);
            }
            if($jpeg !== false)
            {
                list($width, $height) = getimagesize($file);
                list($newwidth, $newheight) = getimagesize($smp_options['overlay_text']);
                if($width !== 0 && $height !== 0 && $newwidth !== 0 && $newheight !== 0)
                {
                    $out = imagecreatetruecolor($width, $height);
                    if($out !== false)
                    {
                        $imglocation = explode(',', $smp_options['overlay_location']);
                        if(isset($imglocation[1]))
                        {
                            $dx = trim($imglocation[0]);
                            $dy = trim($imglocation[1]);
                        }
                        else
                        {
                            $dx = 0;
                            $dy = 0;
                        }
                        if(imagecopyresampled($out, $jpeg, 0, 0, 0, 0, $width, $height, $width, $height))
                        {
                            if(imagecopyresampled($out, $png, $dx, $dy, 0, 0, $newwidth, $newheight, $newwidth, $newheight))
                            {
                                $rez = imagejpeg($out, $file, 100);
                                if($rez === false)
                                {
                                    smp_log_to_file('Failed to create final overlay image');
                                }
                            }
                            else
                            {
                                smp_log_to_file('Failed to imagecopyresampled (png)');
                            }
                        }
                        else
                        {
                            smp_log_to_file('Failed to imagecopyresampled (jpeg)');
                        }
                    }
                    else
                    {
                        smp_log_to_file('Failed to imagecreatetruecolor');
                    }
                }
                else
                {
                    smp_log_to_file('Failed to create new image resource');
                }
            }
            else
            {
                smp_log_to_file('Failed to create featured image resource from: ' . $file);
            }
        }
        else
        {
            smp_log_to_file('Failed to create image resource from: ' . $smp_options['overlay_text']);
        }
    }
    if(isset($smp_options['fimage']) && $smp_options['fimage'] == 'on')
    {
        $wp_filetype = wp_check_filetype($filename, null);
        if($wp_filetype['type'] == '')
        {
            $wp_filetype['type'] = 'image/png';
        }
        $attachment  = array(
            'post_mime_type' => $wp_filetype['type'],
            'post_title' => sanitize_file_name($filename),
            'post_content' => '',
            'post_status' => 'inherit'
        );
        $attach_id   = wp_insert_attachment($attachment, $file, $post_id);
        if ($attach_id === 0) {
            return false;
        }
        require_once(ABSPATH . 'wp-admin/includes/image.php');
        require_once(ABSPATH . 'wp-admin/includes/media.php');
        $attach_data = wp_generate_attachment_metadata($attach_id, $file);
        wp_update_attachment_metadata($attach_id, $attach_data);
        $res2 = set_post_thumbnail($post_id, $attach_id);
        if ($res2 === FALSE) {
            return false;
        }
        $post_title = get_the_title($post_id);
        if($post_title != '')
        {
            update_post_meta($attach_id, '_wp_attachment_image_alt', $post_title);
        }
    }
    return $urls;
}
?>