<?php
   function smp_logging()
   {
       global $wp_filesystem;
       if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
           include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
           wp_filesystem($creds);
       }
       if(isset($_POST['smp_delete']))
       {
           if($wp_filesystem->exists(WP_CONTENT_DIR . '/smp_info.log'))
           {
               $wp_filesystem->delete(WP_CONTENT_DIR . '/smp_info.log');
           }
       }
   ?>
<div class="wp-header-end"></div>
<div class="wrap gs_popuptype_holder seo_pops">
   <div>
      <div class="hideMain">
         <h3>
            <?php echo esc_html__('Activity Log:', 'smp-youtube-mass-poster');?>
            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
               <div class="bws_hidden_help_text cr_min_260px">
                  <?php
                     echo esc_html__("This is the main log of your plugin. Here will be listed every single message issued by the plugin.", 'smp-youtube-mass-poster');
                     ?>
               </div>
            </div>
         </h3>
         <div>
            <?php
               if($wp_filesystem->exists(WP_CONTENT_DIR . '/smp_info.log'))
               {
                   $log = $wp_filesystem->get_contents(WP_CONTENT_DIR . '/smp_info.log');
                   $log = esc_html($log);$log = str_replace('&lt;br/&gt;', '<br/>', $log);echo $log;
               }
               else
               {
                   echo esc_html__('Log empty', 'smp-youtube-mass-poster');
               }
               ?>
         </div>
      </div>
      <hr/>
      <form method="post" onsubmit="return confirm('<?php echo esc_html__('Are you sure you want to delete all logs?', 'smp-youtube-mass-poster');?>');">
         <input name="smp_delete" type="submit" value="<?php echo esc_html__('Delete Logs', 'smp-youtube-mass-poster');?>">
      </form>
   </div>
</div>
<?php
   }
   ?>